﻿//----------------------------------------------------------------
// Varsion
// 0.3.0 2016_12_12 基本系統の作成
//					バットとボールの接触判定作成（ガバ）
//					ボールを打ちかえす処理の作成
//					ボールのあたる位置によって左右に飛んでいく処理の作成
//0.4.0 2016_12_13 ストライク処理の作成
//					５球すべて打つとゲームクリア
//					３ストライクでゲーム終了
//					ゲームの基本完成
// 0.4.1 2016_12_13 WolfGame_Base 変更に伴い、ピクチャの最大、最小の変数を削除
//					グッド、バッドエフェクトの追加
// 0.4.3 2016_12_14 SEの追加
//					BGMの追加
// 0.5.0 2016_01_10 anCria　追加
//
//----------------------------------------------------------------
/*:ja
*@plugindesc ババゼブブとのバッティングゲーム
*@author うるふ
*
*@param Unknown Date
*@desc プロトタイプ
*default 不明
*
*@help
*
*ババゼブブとのバッティングゲーム
*
*
*/



(function() {

	//==================================
	//オブジェクト生成
	//==================================

	function WolfGame_Batting(){
		this.initialize.call(this);

	}


	//ゲームベースを継承
	WolfGame_Batting.prototype = Object.create(WolfGame_Base.prototype);
	WolfGame_Batting.prototype.constructor = WolfGame_Batting;


	//==================================
	//変数
	//==================================



	//==================================
	// プラグインパラメータ取得
	//==================================

	//パラメータ取得するときに使用
	var Parameters = PluginManager.parameters('Wolf_BattingGame');

	//=======================================
	// WolfGame_Batting メソッド
	//=======================================

	//=============================-
	// ゲーム基本メソッド
	//=============================-

	WolfGame_Batting.prototype.initialize = function(){
		WolfGame_Base.prototype.initialize.call(this);
		//this._minPicId = 1;
		//this._maxPicId = 15;

		this._posiBall = [ 408, 0];

		this._addBallX = 0;
		this._addBallY = 0;

		this._actBall = false;
		this._acceleBall = 0.8;
		this._timeBall = 0; //加速時間
		this._voBall = 15;//ボールの初速

		this._spdBall = 1;
		this._actHit = false;

		this._remeBall = 5;

		this._posiBat = [ 300, 544];
		this._angleBat = -80;
		this._actBat = false;
		this._spdBat = 15;

		this._throwFram = 60;
		this._throwCount  =0;

		this._strike = 0;

		//se file name 
		this._seHit = "ko1";
		this._seStrike = "Blow2";
		this._seThrow  = "Fall";
		this._seSwing = "Evasion1";
		this._seFanfare = "correct1";

		//bgm file name
		this._bgm = "WILD_BOYS";
	}

	WolfGame_Batting.prototype.risetAll = function(){
		this.risetBall();
		this.risetBat();
		this.risetPitcher();

	}

	WolfGame_Batting.prototype.risetBall = function(){
		this._posiBall = [408 , 50];
		this._spdBall = 1;
		this._actBall = false;
		this._actHit = false;
		this._addBallX = 0;
		this._addBallY = 0;
		this._timeBall = 0;


	}

	WolfGame_Batting.prototype.risetBat = function(){
		this._angleBat = 0;
		this._actBat = false;
	}

	WolfGame_Batting.prototype.risetPitcher = function(){
		this._throwCount = this._throwFram;
		this._remeBall = 5;
		this._strike = 0;

	}

	WolfGame_Batting.prototype.set = function(){
		WolfGame_Base.prototype.set.call(this);
		WolfGame_Base.prototype.playBgm.call(this,this._bgm);
		this.risetAll();
		this.draw();
	};


	WolfGame_Batting.prototype.main = function(){
		WolfGame_Base.prototype.main.call(this);
		this.update();
		this.draw();

	};

	WolfGame_Batting.prototype.end = function(){
		WolfGame_Base.prototype.end.call(this);
	}


	//=============================-
	// ゲーム更新関係
	//=============================-

	WolfGame_Batting.prototype.update = function(){

		this.updateInput();

		if(this._actBall){
			this.updateBall();
		}
		this.updateBat();
		this.countThrowWait();

		this.checkCollisionBall();
		this.criaGame();
		this.overGame();
	}

	//クリックを取得
	WolfGame_Batting.prototype.updateInput = function(){

		if($gameSystem.wolfIsTriggeredOkorTouch()){
			WolfGame_Base.prototype.playSe(this._seSwing);//SEの再生
			this._actBat = true;
		}
	}

	WolfGame_Batting.prototype.updateBall = function(){

		this.forwardBall();
		this.accelerBall();

		if(this.checkBallHit()){
			WolfGame_Base.prototype.playSe(this._seHit);//SEの再生
			this.reflectBall();
		}
			
		if(this.checkBallOut()){
			this.setPitcher();	
		}

	}

	WolfGame_Batting.prototype.setPitcher = function(){
			this._throwCount = this._throwFram;
			this.setBall(48 + 15);
			this._actBall = false;
			this._remeBall -= 1;

	}

	WolfGame_Batting.prototype.countThrowWait = function(){
			this._throwCount -= 1;
			//console.log("count = " + this._throwCount);
			if(this._throwCount == 0){
				this._actBall = true;
				WolfGame_Base.prototype.playSe(this._seThrow);//SEの再生
			}

	}

	WolfGame_Batting.prototype.accelerBall = function(){
		this._addBallY = this._voBall + this._acceleBall * this._timeBall;
		this._addBallY *= this._spdBall;
		this._timeBall += 1;

	}

	WolfGame_Batting.prototype.forwardBall = function(){

		this._posiBall[0] += this._addBallX;
		this._posiBall[1] += this._addBallY;

	}

	//ボールが打たれたか判定
	WolfGame_Batting.prototype.checkBallHit = function(){

		if(this.checkCollisionBall() && this._actHit == false && this._posiBall[1] > this._posiBat[1] - 250){
			return true;
		}else{
			return false;
		}
	}

	//ボールが画面外に出たかどうか判定
	WolfGame_Batting.prototype.checkBallOut = function(){

		//if(this._posiBall[1] > 824 || this._posiBall[1] < -224){
		if(this._posiBall[1] < -224){
			return true;
		}else{
			return false;
		}
	}

	//ストライク
	WolfGame_Batting.prototype.checkStrike = function(){
		if(this._posiBall[1] > 1024 ){
			//WolfGame_Base.prototype.onEndSwitche.call(this);//とりあえず終了
			return true;

		}
		else{
			return false;
		}

	}

	WolfGame_Batting.prototype.criaGame = function(){
		if(this._remeBall <= 0){
			WolfGame_Base.prototype.playSe(this._seFanfare);//SEの再生
			WolfGame_Base.prototype.onEndSwitche.call(this);//とりあえず終了			
		}
	}

	WolfGame_Batting.prototype.overGame = function(){
		if(this.checkStrike()){
			this._strike += 1;
			this.setPitcher();
			WolfGame_Base.prototype.playSe(this._seStrike);//SEの再生
			WolfGame_Base.prototype.criateMarkEffect.call(this,408,624 - 80,"BAD");//ストライクでバッドエフェクトの作成
		}
	
		if(this._strike >= 3){
			//非ゲームクリアのフラグを上げる
			WolfGame_Base.prototype.onAnCriaSwitche.call(this);
			WolfGame_Base.prototype.onEndSwitche.call(this);//とりあえず終了			

		}
		

	}

	WolfGame_Batting.prototype.updateBat = function(){

		this.swingBat(this._actBat);

		//一回転したらフラグを降ろす
		if(this.oneRotation()){
			this._actBat = false;
		}
	}

	WolfGame_Batting.prototype.swingBat = function(flag){

		if(flag){
			this._angleBat -= this._spdBat;		
		}
	}

	//一回転したら０に戻す
	WolfGame_Batting.prototype.oneRotation = function(){

		if(this._angleBat < -360){
			this._angleBat = 0;
			return true;
		}
		else{
			return false;
		}

	}

	//ボールをセッティング
	WolfGame_Batting.prototype.setBall = function(y){
		this.risetBall();
		this._posiBall[1] = y;
	}

	//ボールが跳ね返る
	WolfGame_Batting.prototype.reflectBall = function(){
		this._spdBall *= -1;
		this._addBallX = this._posiBall[1] - this._posiBat[1] + 29;
		this._addBallX = Math.min(this._addBallX,20);

		this._actHit = true;
		if(this._addBallX == 0){
			WolfGame_Base.prototype.criateMarkEffect.call(this,this._posiBall[0],this._posiBall[1] - 100,"VERYGOOD");//攻撃できたらグッドエフェクトの作成
		}else{
			WolfGame_Base.prototype.criateMarkEffect.call(this,this._posiBall[0],this._posiBall[1] - 100,"GOOD");//攻撃できたらグッドエフェクトの作成

		}
	}

	//バットにボールが当たったか判定（ガバ）
	WolfGame_Batting.prototype.checkCollisionBall = function(){

		var x = this._posiBall[0] - this._posiBat[0];
		var y = this._posiBall[1] - this._posiBat[1];
		var angle = Math.atan(y / x) * 180 / Math.PI;

		if(Math.abs(angle - this._angleBat - 180) < 22 || Math.abs(angle - this._angleBat - 180) > 360 - 22){
			return true;
		}
		return false;

	}
	//=============================-
	// ゲーム描画関係
	//=============================-

	WolfGame_Batting.prototype.draw = function(){
		WolfGame_Base.prototype.draw.call(this);
		this.drawBackGround(1);
		this.drawPitcher(2);
		this.drawScoreBoard(4);
		this.drawRestStool(5);//5 + 5
		this.drawBat(10);
		this.drawBall(11);
		this.drawStrike(12);//12 + 3
	}

	WolfGame_Batting.prototype.drawBackGround = function(id){		
		$gameScreen.showPicture(id,"Batting_BackGround",0,0,0,100.0,100.0,255,0);	
	}

	WolfGame_Batting.prototype.drawPitcher = function(id){
		$gameScreen.showPicture(id,"Batting_Pitcher",1,408,96 / 2 + 15,100.0,100.0,255,0);	

	}



	WolfGame_Batting.prototype.drawScoreBoard = function(id){
		$gameScreen.showPicture(id,"Batting_ScoreBoard",0,816 - 250 -15 ,624 - 200 - 15,100.0,100.0,255,0);	

	}

	WolfGame_Batting.prototype.drawRestStool = function(id){
		for(var i = 0 ; i < this._remeBall ; i++){
			var y = 72 / 2 + 8 + 72 * i + 8 * i;
			$gameScreen.showPicture(id + i,"Batting_RestStool",1,816 - 72 / 2 - 10 ,y,100.0,100.0,255,0);	
		}
	}

	WolfGame_Batting.prototype.drawBat = function(id){
			$gameScreen.showPicture(id,"Batting_Bat",1,this._posiBat[0],this._posiBat[1],100.0,100.0,255,0);	
			$gameScreen.picture(id).changeAngle(this._angleBat - 180);

	}

	WolfGame_Batting.prototype.drawBall = function(id){
			$gameScreen.showPicture(id,"Batting_Ball",1,this._posiBall[0],this._posiBall[1],100.0,100.0,255,0);	

	}

	WolfGame_Batting.prototype.drawStrike = function(id){
		for(var i = 0 ; i < this._strike ; i++){
			$gameScreen.showPicture(id + i,"Batting_Strike",0,816 - 250 -15  + 22.5 + 60 * i + 15 * i,624 - 200 - 15 + 70,100.0,100.0,255,0);	
		}

	}

	//=============================-
	// ゲーム終了関係
	//=============================-
	
	//=========================================
	//オブジェクト生成
	//=========================================
	var _WolfGame_Batting = new WolfGame_Batting();


	//=========================================
	// プラグインコマンドで制御
	//=========================================

	var _Game_Interpreter_pluginCommand = Game_Interpreter.prototype.pluginCommand;
	Game_Interpreter.prototype.pluginCommand = function(command,args)
	{
		_Game_Interpreter_pluginCommand.call(this,command,args);

		if(command === 'Wolf_BattingGame'){

			switch (args[0])
			{
			case 'set':
				_WolfGame_Batting.set();
				console.log("set");
				
				break;			

			case 'main':
				_WolfGame_Batting.main();
				break;
			case 'end':
				_WolfGame_Batting.end();
				break;			
	
			}
		}

	};
		




})();
