﻿//----------------------------------------------------------------
// Varsion
// 0.4.0 2016_12_10 基本系の作成
//					敵に当たるとゲームオーバー
//					障害物に当たるとこける
//					ゴールするとクリア
// 0.4.1 2016_12_13 WolfGame_Base 変更に伴い、ピクチャの最大、最小の変数を削除
//					グッド、バッドエフェクトの追加
// 0.4.4 2016_12_14 SEの追加
//					BGMの追加
//					window で取得していた変数がクロームでうまくできなかったので、408,312と直接代入に変更		
// 0.5.0 2017_01_10 anCria 追加
//
//----------------------------------------------------------------


/*:ja
*@plugindesc クソフェゴールから逃げるゲーム
*@author うるふ
*
*@param Unknown Date
*@desc プロトタイプ
*default 不明
*
*@help
*
*クソフェゴールから逃げるゲーム
*
*
*
*/



(function() {

	//==================================
	//オブジェクト生成
	//==================================

	function WolfGame_Dash(){
		this.initialize.call(this);
	}

	//ゲームベースを継承
	WolfGame_Dash.prototype = Object.create(WolfGame_Base.prototype);
	WolfGame_Dash.prototype.constructor = WolfGame_Dash;

	//==================================
	// プラグインパラメータ取得
	//==================================

	//パラメータ取得するときに使用
	var Parameters = PluginManager.parameters('Wolf_DashGame');

	//=======================================
	// WolfGame_Dash メソッド
	//=======================================

	WolfGame_Dash.prototype.initialize = function(){
		WolfGame_Base.prototype.initialize.call(this);
		//this._minPicId = 1;
		//this._maxPicId = 20;

		
		this._positionP = [0,0];//プレイヤー座標
		this._runFlag = false;
		this._spdP = 1;

		this._stumbleFrame = 120;//こけて起き上がるまでのフレーム数
		this._stumbleCount = 0;//こけて起き上がるまでのフレーム
		this._invincibleFrame = this._stumbleFrame + 60;//無敵フレーム数
		this._invincibleCount = 0;

		//ジャンプ制御用のタイム
		this._timeCount = 0;
		this._timeMax = 30;

		//ジャンプ制御
		this._jumpFlag = false;
		this._jumpPower = 8;
		this._jumpAddY = 0;

		this._positionE = [0,0];//エネミー座標
		this._spdE = 1;
		this._countActE = -90;//敵が動くフラグ,0になると動く

		//障害物のx座標
		this._positionO = [ 200, 350, 450, 600, 700, 800];

		//SE file name
		this._seJump = "Jump1";
		this._seStuble = "Blow2";
		this._seDash = "Run";
		this._seScream = "Scream";
		this._seFanfare = "correct1";

		//bgm file name
		this._bgm = "Primitive_of_Jean";
	}

	//=============================-
	// ゲーム初期化関係
	//=============================-

	//変数初期化
	WolfGame_Dash.prototype.risetAll = function(){
		this.risetPlayer();
		this.risetEnemy();
		this.risetJump();
	}

	//プレイヤー関係の変数
	WolfGame_Dash.prototype.risetPlayer = function(){
		this._positionP[0] = 50 + 25;
		this._positionP[1] = 312;

		this._stumbleCount = 0;//こけて起き上がるまでのフレーム
		this._invincibleCount = 0;//無敵フレーム



	};
	//エネミー関係の変数
	WolfGame_Dash.prototype.risetEnemy = function(){
		this._positionE[0] = -25;
		this._positionE[1] = 312;
		this._countActE = -90;
	};
	//ジャンプ関係の変数
	WolfGame_Dash.prototype.risetJump = function(){
		this._runFlag = false;
		this._jumpFlag = false;
		this._timeCount = 0;
		this._jumpAddY = 0; 
	}

	//=============================-
	// ゲーム基本メソッド
	//=============================-


	WolfGame_Dash.prototype.set = function(){
		WolfGame_Base.prototype.set.call(this);
		WolfGame_Base.prototype.playBgm.call(this,this._bgm);
		this.risetAll();
	};


	WolfGame_Dash.prototype.main = function(){
		WolfGame_Base.prototype.main.call(this);
		this.update();
		this.draw();

	};

	WolfGame_Dash.prototype.end = function(){
		WolfGame_Base.prototype.end.call(this);
	}


	
	//=============================-
	// ゲーム更新関係
	//=============================-

	WolfGame_Dash.prototype.update = function(){
		this.updateRun();
		this.updateEnemy();

		this.updateJump();

		this.checkCollisonAll();

		this.countupInvincible();
		this.countupStumble();

		this.onGoal();
	}
	//走る
	WolfGame_Dash.prototype.updateRun = function(){
		//こけていなけば実行
		if(this._stumbleCount <= 0){
			this.playDash();
			//ボタンを押しているとき走る
			if($gameSystem.wolfIsPressedOkorTouch()){
				this._positionP[0] += this._spdP;
				this._runFlag = true;

			}else{
				//ボタンを離したときにジャンプ
				if(this._runFlag == true && this._jumpFlag == false){	
					WolfGame_Base.prototype.criateMarkEffect.call(this,this._positionP[0],this._positionP[1] - 100,"GOOD");//ジャンプしたときエフェクト		
					WolfGame_Base.prototype.playSe(this._seJump);//SEの再生
					this.onJump();
				}
			}
		}
	}

	//ダッシュの効果音
	WolfGame_Dash.prototype.playDash = function(){
		if($gameSystem.wolfIsTriggeredOkorTouch()){
				WolfGame_Base.prototype.playSe(this._seDash);//SEの再生

		}		
	}

	//ジャンプする
	WolfGame_Dash.prototype.updateJump = function(){
		if(this._jumpFlag){
			this._jumpAddY = this._jumpPower * Math.sin(Math.PI * 2 / this._timeMax * this._timeCount);
			this._positionP[1] -= this._jumpAddY;
			this._positionP[0] += this._spdP * 2;
			this._timeCount += 1;
			//ジャンプフラグを降ろす
			if(this._timeCount >= this._timeMax){
				this._jumpFlag = false;
			}
		}
	}

	//無敵フレーム減算
	WolfGame_Dash.prototype.countupInvincible = function(){
		if(this._invincibleCount > 0){
			this._invincibleCount -= 1;
		}
	}
	//こけたフレーム減算
	WolfGame_Dash.prototype.countupStumble = function(){
		if(this._stumbleCount > 0){
			this._stumbleCount -= 1;
		}
	}

	//ジャンプフラグを立てる
	WolfGame_Dash.prototype.onJump = function(){
		this._jumpFlag = true;
		this._runFlag = false;
		this._timeCount = 0;	
	}

	//敵を進める
	WolfGame_Dash.prototype.updateEnemy = function(){
		//進ませるまでウェイトを持たせる
		if(this._countActE >= 0){
			this._positionE[0] += this._spdE;
		}else{
			this._countActE += 1;
		}
	}

	WolfGame_Dash.prototype.checkCollisonAll = function(){
		this.checkCollisonObsta();
		this.checkCollisonEnemy();

	}

	WolfGame_Dash.prototype.checkCollisonObsta = function(){

		if(this._invincibleCount <= 0){
			for(var i = 0 ; i < 6 ; i++){

				//プレイヤーと障害物の接触判定
				if($gameSystem.wolfIsCollisionCircle(this._positionP[0],this._positionP[1],24,24,this._positionO[i],312,12,12)){
					this.onStumble();
				}
			}
		}
	}

	WolfGame_Dash.prototype.checkCollisonEnemy = function(){
		//プレイヤーと敵の接触判定
		if(!this._jumpFlag){
			if($gameSystem.wolfIsCollisionCircle(this._positionP[0],this._positionP[1],24,24,this._positionE[0],this._positionE[1],12,12)){
				WolfGame_Base.prototype.playSe(this._seScream);//SEの再生
				//非ゲームクリアのフラグを上げる
				WolfGame_Base.prototype.onAnCriaSwitche.call(this);
				WolfGame_Base.prototype.onEndSwitche.call(this);
			}
		}
	}

	//こける変数処理
	WolfGame_Dash.prototype.onStumble = function(){
		this._stumbleCount = this._stumbleFrame;
		this._invincibleCount = this._invincibleFrame;
		WolfGame_Base.prototype.criateMarkEffect.call(this,this._positionP[0],this._positionP[1] + 100,"BAD");//バッドエフェクトの作成
		WolfGame_Base.prototype.playSe(this._seStuble);//SEの再生

	}

	//ゴールでゲームクリア
	WolfGame_Dash.prototype.onGoal = function(){
		if(this._positionP[0] > 816){
			WolfGame_Base.prototype.playSe(this._seFanfare);//SEの再生
			WolfGame_Base.prototype.onEndSwitche.call(this);
		}
	}



	//=============================-
	// ゲーム描画関係
	//=============================-

	WolfGame_Dash.prototype.draw = function(){
		//WolfGame_Base.prototype.draw.call(this);
		this.drawGameBase();
		this.drawBackGround(1);
		//this.drawBackEnemy(2);
		//this.drawBackPlayer(3);
		//this.drawBackObstacle(4);//4 + 6 = 10
		this.drawDashBar(10);
		this.drawPlayer(11);
		this.drawEnemy(12);
		//this.drawGoal(13);
		this.drawObstacle(14);//14 + 6 
		this.drawEffect(20);

	}

	//ゲームベースの中身を少し変える
	WolfGame_Dash.prototype.drawGameBase = function(){
		$gameSystem.wolfPictureErase(1,1);
		$gameSystem.wolfPictureErase(4,60);
		WolfGame_Base.prototype.drawMarkEffect.call(this);//エフェクトの表示
	}

	WolfGame_Dash.prototype.drawBackGround = function(id){
		$gameScreen.showPicture(id,"Dash_BackGround",0,0,0,100.0,100.0,255,0);	

	}

	WolfGame_Dash.prototype.drawBackEnemy = function(id){
		$gameScreen.showPicture(id,"Dash_BackEnemy",1,408,321,100.0,100.0,255,0);	

	}

	WolfGame_Dash.prototype.drawBackPlayer = function(id){
		$gameScreen.showPicture(id,"Dash_BackPlayer",1,408,321,100.0,100.0,255,0);	
		
	}

	WolfGame_Dash.prototype.drawBackObstacle = function(id){
		$gameScreen.showPicture(id,"Dash_BackObstacle",1,408,321 + 100,100.0,100.0,255,0);	
		
	}

	WolfGame_Dash.prototype.drawPlayer = function(id){
		var opp = 255;
		if(this._stumbleCount > 0){
			opp = 100;
		}
		$gameScreen.showPicture(id,"Dash_Player",1,this._positionP[0],this._positionP[1],100.0,100.0,opp,0);
	}

	WolfGame_Dash.prototype.drawDashBar = function(id){
		$gameScreen.showPicture(id,"Dash_DashBar",1,408,312,100.0,100.0,255,0);

	}

	WolfGame_Dash.prototype.drawEnemy = function(id){
		$gameScreen.showPicture(id,"Dash_Enemy",1,this._positionE[0],this._positionE[1],100.0,100.0,255,0);

	}

	WolfGame_Dash.prototype.drawGoal = function(id){
		$gameScreen.showPicture(id,"Dash_Goal",1,816 - 12,321,100.0,100.0,255,0);

	}

	WolfGame_Dash.prototype.drawObstacle = function(id){
		for(var i = 0 ; i < 6 ; i++){
		$gameScreen.showPicture(id + i,"Dash_Obstacle",1,this._positionO[i],321,100.0,100.0,255,0);
		}
	}

	WolfGame_Dash.prototype.drawEffect = function(id){
		if(this._runFlag) $gameScreen.showPicture(id,"kasoku01",0,0,0,100.0,100.0,255,0);
	}



	//=============================-
	// ゲーム終了関係
	//=============================-
	
	//=========================================
	//オブジェクト生成
	//=========================================
	var _WolfGame_Dash = new WolfGame_Dash();


	//=========================================
	// プラグインコマンドで制御
	//=========================================

	var _Game_Interpreter_pluginCommand = Game_Interpreter.prototype.pluginCommand;
	Game_Interpreter.prototype.pluginCommand = function(command,args)
	{
		_Game_Interpreter_pluginCommand.call(this,command,args);

		if(command === 'Wolf_DashGame'){

			switch (args[0])
			{
			case 'set':
				_WolfGame_Dash.set();
				break;			

			case 'main':
				_WolfGame_Dash.main();
				break;
			case 'end':
				_WolfGame_Dash.end();
				break;			
	
			}
		}

	};
		




})();
