﻿//===========================================
// varsion 0.7.1 追加 マップメモにdestGame が書いてあると並列起動のスイッチを入れる　
// varsion 0.7.2 追加　MOG_CharShatterEffect 用に破壊したeventId を変数に格納
//					  破壊後にオブジェクトを飛ばしているのを削除（不具合でる可能性あり）(煙をだすならこっちにする必要あり)
// varsion 0.7.3 修正 破壊判定をページ番号に依存する
//				 追加 ミスのアクションを前方オブジェクトのみに適用
//				 　　　 アニメーションをスクリプトで実行
// varsion 0.7.35修正 プレイヤーのキャンバス座標の不具合を修正
// varsino 0.7.36修正 プレイヤーのキャンバス座標の不具合を修正
// varsion 0.8.0 修正　トリアコンタンさまのプラグインを使用して、分裂タイプをイベントの生成に変更、ソースを大幅に削ったので前バージョンでの分裂動作は不可
// varsion 0.8.2 変更　UIをメータに変更
// varsion 0.8.3 追加　ゲームクリアを設定、マップのオブジェクトの数を取得
// varsion 0.9.0 修正　いらないメソッドを整理　2017_05_13
// varsion 0.9.2 追加　並列実行していた処理をスクリプトないで制御　2017_05_13
// varsion 0.9.3 追加　破壊時にオブジェクトの削除（モバイル版）　2017_05_14
// varsion 0.9.4 修正　モバイル時に、あたり判定を拡張　2017_05_14
// varsion 0.9.5 修正　モバイル時に、クリア条件を変更　2017_05_14
// varsion 0.9.6 修正　モバイル時、一定のステージではイベントの削除を無視　2017_05_15
//
//
//===========================================
/*:ja
*@plugindesc デストロイヤーシステム（プロトタイプ）
*@author うるふ
*Copyright 2016 うるふ
*
*@param Change Animation Value
*@dest 破壊時のアニメーションを切り替える変数
*@default 1
*
*@param Destroy ComonEventId
*@desc 攻撃成功時に実行するコモンイベント
*@default 5
*
*@param  Hyper Value
*@desc テンションゲージを格納する変数
*default 2
*
*@param  Combo Value
*@desc 現在のコンボを格納する変数
*@default 8
*
*@param  Critical Value
*@desc 現在のクリティカル率を格納する変数
*@default 9
*
*@param  Smoke Value
*@desc 破壊後煙になる確率を格納する変数
*@default 11
*@help
*
*@param  Smoke Probability
*@desc 煙になる確率（パーセント）;
*@default 30
*
* @param Set CHEffect Value
* @desc イベントエフェクトにイベントいｄを渡す変数
* @default 4
*
* @param Set Cria Switch Value
* @desc クリアした時にオンにするスイッチ
* @default 3
*
* @param Set Stage Value
* @desc 現在のステージを格納する変数番号
* @default 17
*
* @param Set Cria Value
* @desc クリア条件を表示するための変数
* @default 18
*
* @param Dest Object Value
* @desc 破壊オブジェクトカウント変数番号
* @default 19
*
*
*プロトタイプです
*
*
*
*/

(function() {

//=============================
//変数
//==============================

	//テスト、最大テンション
	//var testMaxHyper = 5;
	//テンション最大値
	var maxHyper = 0;
	//テスト、オブジェクトの数
	//var testMaxObject = 0;
	//ステージ番号
	var stageNum = 0;

	//破壊するオブジェクトのタイプ
	//(1 = 爆発 2 = 凍らせる、3 = 分裂親、4 = 分裂子、5 = 分裂孫、6 = 貪る、7 = 溢れ出る、8 = 聖水オブジェクト)

	//主人公の方向を取得して格納
	var playerDirection = 0;

	//テンションゲージのピクチャＩＤ
	var hyperPicId = 10;
	
	//キャラ番号取得変数の番号
	var destCharacterVarue = 3;
	
		
	//色調
	var screen_color_r = 0.0;
	var screen_color_g = 0.0;
	var screen_color_b = 0.0;

	//アニメーション実行ディレイ
	var animFleam = 0;
	var animMaxFleam = 30;

	//====================--
	//パラメーター取得
	//===================--
	
	var Parameters = PluginManager.parameters('Wolf_DestroyerSystem');
	
	//攻撃成功時にtrueを入れるスイッチの番号
	var change_animation_value = Number(Parameters['Change Animation Value']);
	
	//攻撃成功時に実行するコモンイベント
	var destroy_comoneventId = Number(Parameters['Destroy ComonEventId']);
	
	
	//テンションゲージ格納変数番号
	var hyperLevel_value = Number(Parameters['Hyper Value']);
	
	//UI引き渡し変数
	var combo_value = Number(Parameters['Combo Value']);//コンボ
	var critical_value = Number(Parameters['Critical Value']);//クリティカル

	//煙
	var smoke_value = Number(Parameters['Smoke Value']);
	var smoke_proba = Number(Parameters['Smoke Probability']);

  	var valueSetCHEffect = Number(Parameters['Set CHEffect Value']);

  	//クリア変数
  	var valueSwitchCria = Number(Parameters['Set Cria Switch Value']);
  	var valueCria 		= Number(Parameters['Set Cria Value']);

  	//ステージ格納変数
  	var valueStage = Number(Parameters['Set Stage Value']);

  	//デストオブジェクトカウント
  	var valueDestCount = Number(Parameters['Dest Object Value']);

  	var isMobile = Utils.isMobileDevice();//モバイル判定

	//============================-
	//データベース
	//============================-

	//オブジェクト耐久値のデータ
	var durable_data = [
		{"id":0,"durable":0},
		{"id":1,"durable":1},
		{"id":2,"durable":50},
		{"id":3,"durable":250},
		{"id":4,"durable":1250},
		{"id":5,"durable":6250},
		{"id":6,"durable":31250},
		{"id":7,"durable":156250},
		{"id":8,"durable":781250},
		{"id":9,"durable":3906250},
		{"id":10,"durable":19531250}
	]
	
	//オブジェクト使用カウントのデータ
	var dcount_data = [
		{"id":0,"count":0},
		{"id":1,"count":0},
		{"id":2,"count":0},
		{"id":3,"count":0},
		{"id":4,"count":0},
		{"id":5,"count":0},
		{"id":6,"count":0},
		{"id":7,"count":120},
		{"id":8,"count":0}
	]
	
	//レベル上昇に必要なテンション値
	var level_date = [
		
		{"id":1,"exp":4},
		{"id":2,"exp":200},
		{"id":3,"exp":1000},
		{"id":4,"exp":5000},
		{"id":5,"exp":25000},
		{"id":6,"exp":125000},
		{"id":7,"exp":625000},
		{"id":8,"exp":3125000},
		{"id":9,"exp":15625000}
	
	]
	
	//攻撃力
	var pow_date = [
	
		{"id":1,"pow":1},
		{"id":2,"pow":50},
		{"id":3,"pow":250},
		{"id":4,"pow":1250},
		{"id":5,"pow":6250},
		{"id":6,"pow":31250},
		{"id":7,"pow":156250},
		{"id":8,"pow":781250},
		{"id":9,"pow":3906250},
		{"id":10,"pow":19531250}

		
	
	]

	var maxHyper_data = [
		{"id":1,"max":2},
		{"id":2,"max":8},
		{"id":3,"max":3},
		{"id":4,"max":8},
		{"id":5,"max":6},
		{"id":6,"max":6},
		{"id":7,"max":3}
	]

	//アニメーションIDの配列(1:なし、2:通常破壊、3:クリティカル、4:爆発、5:音なしの破壊アニメーション)
	var anim_id = [0,0,123,22,33,124];

	//=================================-
	//汎用関数
	//=================================-

	//セルフスイッチのセット
	function ThisMapSelfSwichesSet(swit,eventId)
	{
			//キーのセッティング
			var mapid = $gameMap.mapId();	
			var key = [mapid,eventId,swit];
			
			$gameSelfSwitches.setValue(key,true);

		
	}

	//セルフスイッチのリセット
	function ThisMapSelfSwichesRiset(swit,eventId)
	{
			//キーのセッティング
			var mapid = $gameMap.mapId();	
			var key = [mapid,eventId,swit];
			
			$gameSelfSwitches.setValue(key,false);

		
	}

	function eraseEventStage(){
		var bool = true;
		switch(stageNum){
			case 6:
				bool = false;
				break;
			case 7:
				bool = false;
				break;
		}
		return bool;
	}
	
	//オブジェクトの破壊
	function ObjectDelete(eventId){
		ThisMapSelfSwichesSet("A",eventId)
		
		
		//object[eventId] = 0;
		var events = $gameMap.event(eventId);
		//耐久値を０にする
		events.destDurableRiset();


		//軽量化のため、モバイル版で、オブジェクトの削除を行う
		//多分、歩行アニメが重さの原因の一つだとおもうんですよね～
		//もちろんオブジェクト数も問題だけど・・・それは今の僕には解決できないでーすwww
		if(isMobile && eraseEventStage()) $gameMap.eraseEvent(eventId);

		
	}
	
	//主人公マップ座標X
	function playerCanvasX(x){
		
		  var tileWidth = $gameMap.tileWidth();
		  var dividePointUp = Math.floor(17/2);
		  var dividePointDown = $gameMap.width() - Math.floor(17 / 2);


		  //画面中央座標
		  
		  //キャラクターが中心地からスクロールしたら
		  
		  //左方向の座標計算
		  if(x <= dividePointUp){
		  	return 0 + ( 0 + x) * tileWidth;
		  
		  }
		  
		  //右方向の座標計算
		  if(x >= dividePointDown){ 
		  
		  	return 816 - ($gameMap.width() - x ) * tileWidth;
		  
		  }
		  
		  //中心座標
		  return 8 * tileWidth + tileWidth / 2;
		  
		
	}
	
	//主人公マップ座標Y変換
	//修正
	function playerCanvasY(y){

		  var tileHeight = $gameMap.tileHeight();
		  var dividePointUp = Math.floor(13 / 2); 
		  var dividePointDown = $gameMap.height() - Math.floor(13/2);
		  //画面中央座標
		  
		  //キャラクターが中心地からスクロールしたら
		  
		  //上方向の座標計算
		  if(y <= dividePointUp){
		  	
		  	return 0 + ( 0 + y) * tileHeight;
		  
		  }
		  
		  //下方向の座標計算
		  if(y >=  dividePointDown){ 
		  
		  	return 624 - ($gameMap.height() - y ) * tileHeight;
		  
		  }
		  
		  //中心座標
		  return 6 * tileHeight + tileHeight / 2;
	}


	function getEventCanvasX(px,ex){
		var tileWidth = $gameMap.tileWidth();

		//イベントマップ座標からプレイヤーのマップ座標を引く
		var math = ex - px;

		//プレイヤーのキャンバス画像取得
		var cpx = playerCanvasX(px);
		return (cpx + math * tileWidth) + tileWidth / 2;

	}
	
	function getEventCanvasY(py,ey){
		var tileHeight = $gameMap.tileHeight();

		//イベントマップ座標からプレイヤーのマップ座標を引く
		var math = ey - py;

		//プレイヤーのキャンバス画像取得
		var cpy = playerCanvasY(py);
		//console.log("canvas = " + cpy);
		return (cpy + math * tileHeight) - tileHeight ;

	}
	

	//オブジェクト攻撃時に呼ばれる(コモン側で破壊されているのか参照して実行）
	function destroyObject(sucsess,eventId){
		//sucsess 破壊失敗で1、破壊成功で2、クリティカルで3
		
		//console.log("anim = " + sucsess);
		
		//アニメーション切り替え変数を渡す
		$gameVariables.setValue(change_animation_value,sucsess);

		//破壊するイベントIDをセット
		$gameVariables.setValue(valueSetCHEffect,eventId);

		//コモンイベントの実行
		$gameTemp.reserveCommonEvent(5);
		
		//オブジェクトカウント
		countDestObject(1);

		//エンドロールステージ以外でアニメーションを実行
		if($gameVariables.value(valueStage) < 8){
			playDestAnimation(sucsess,eventId)
		}
			
	}

	function countDestObject(add){

		//オビジェクトをカウントする
		var count = $gameVariables.value(valueDestCount);
		$gameVariables.setValue(valueDestCount,count + add);

	}

	//アニメーション実行
	function playDestAnimation(sucsess,eventId){
		sucsess = (sucsess == 2 && animFleam > 0) ? 5 : sucsess; //ディレイがあれば音なしのアニメーション
		//アニメ実行ディレイが0以下の時にも実行
		if(eventId != undefined && eventId != 0){
		var events = $gameMap.event(eventId);
		var px = $gamePlayer._x;
		var py = $gamePlayer._y;
		var x = getEventCanvasX(px,events._x);
		var y = getEventCanvasY(py,events._y);
		PlaceAnimation(anim_id[sucsess],x,y,0,5,0);
		if(animFleam <= 0){
			animFleam = Math.floor(Math.random() * animMaxFleam) + 10;//アニメディレイを設定
		}
		}
	}
	
	//正面ｘ軸取得
	function getFrontPositionX(x,d){
	
		switch (d) {
    	case 2:
      		return x + 0;
     		 break;
    	case 4:
      		return x - 1;
      		break;
    	case 6:
      		return x + 1;
      		break;
    	case 8:
      		return x + 0;
      		break;
    	}
   		 return 0;
	}
	
	//正面ｙ座標取得
	function getFrontPositionY(y,d){
	
		switch (d) {
    	case 2:
      		return y + 1;
     		 break;
    	case 4:
      		return y + 0;
      		break;
    	case 6:
      		return y + 0;
      		break;
    	case 8:
      		return y - 1;
      		break;
    	}
   		 return 0;	
	}
	
		
	//画面を赤く染め上げる
	function Change_S_C(){
	
		screen_color_r += 0.4;
		screen_color_g -= 0.2;
		screen_color_b -= 0.2;
		if(screen_color_r >= 68){
			screen_color_r = 68;
		}
		
		if(screen_color_g <= -34){
			screen_color_g = -34;
		}
		
		if(screen_color_b <= -34){
			screen_color_b = -34;
		}
	
	}

	//DG_PlaceAnimationからいただきました
	//copy(c) 2016 Driftwood Gaming
	//アニメーション再生
	function PlaceAnimation(animid,x,y,mirror,delay,wait){
		var sprite = new Sprite_Base();
    	//var animId = args[0] || DG.Param.DefaultAnim;
    	var animId = animid;

    	sprite.anim = $dataAnimations[animId];
		sprite.x = x;
		sprite.y = y;
		sprite.mirror = mirror;
		sprite.delay = delay;
		sprite.waitFor = wait;
		sprite.dump = true;

		if(SceneManager._scene){  
		SceneManager._scene.addChild(sprite);
		sprite.startAnimation(sprite.anim, sprite.mirror, sprite.delay);
		}
	}

	//配列内でデータがある数をカウント
	function countArray(arr){
		var count = 0;
		for(var i = 0 ; i < arr.length;i++){
			if(arr[i]) count++;
		}
		return count;
	}

	//マップIDからゲーム面を取得
	function getStage(mapId){
		switch(mapId){
			case 8:
				return 1;
				break;
			case 5:
				return 2;
			case 35:
				return 2;//モバイルステージ
				break;
			case 43:
				return 3;
				break;
			case 44:
				return 3;
				break;
			case 45:
				return 3;
				break;
			case 46:
				return 4;
				break;
			case 47:
				return 5;
				break;
			case 48:
				return 6;
				break;
			case 39:
				return 7;
				break;

		}
		return 0;
	}

	//ゲーム前にアニメーション画像を読み込む
	function loadAnimationPictures(){
		ImageManager.loadAnimation("Earth3", 0);
		ImageManager.loadAnimation("Hit2", 0);
		ImageManager.loadAnimation("HitSpecial2", 0);
	}

	//============================================
	//プレイヤーの当たり判定
	//============================================
	
	var _Game_Player_initialize = Game_Player.prototype.initialize;
	Game_Player.prototype.initialize = function() {
		_Game_Player_initialize.call(this);
		this._destContactFlag = false;

	};

	var _Game_Player_isMapPassable = Game_Player.prototype.isMapPassable;
	Game_Player.prototype.isMapPassable = function(x, y, d) {


		return _Game_Player_isMapPassable.call(this,x,y,d);
	
	};

	//連続した接触を防ぐため、移動したら接触フラグを上げる
	var _Game_Player_moveStraight = Game_Player.prototype.moveStraight;
	Game_Player.prototype.moveStraight = function() {
		_Game_Player_moveStraight.apply(this,arguments);
		
		//現在地からオブジェクトの判定を行う
		this.isDestObject(this._x,this._y,this._direction);
	};
	






	Game_Player.prototype.isDestObject = function(x,y,d){

			//スピードアップ時に破壊判定を広げる
			var spdflag = $gameSwitches.value(6);
			if(spdflag == true || isMobile == true){
				this.checkThereDestObject(x,y,d);

			}
			else{
				this.checkOneDestObject(x,y,d);

			}
	};

	//前方１方向の判定
	Game_Player.prototype.checkOneDestObject = function(x,y,d)
	{

		var destId = this.getDestObject(x,y,d);
		
	
		if(destId != 0){
		
			
				//主人公の方向
				playerDirection = d;
				
				//オブジェクトに攻撃
				this.atackObject(destId);	
		}


	};


	//前方３方向の判定
	Game_Player.prototype.checkThereDestObject = function(x,y,d)
	{


		var x2 = x;
		var y2 = y;
	
		//x,y軸方向の当たり判定の拡張
		for(var i = -1  ;i <= 1 ; i++){
		
			if(d == 2 || d == 8){
				x2 = x + i;
			}
			if(d == 4 || d == 6){
				y2 = y +i;
			}
		
		
			var destId = this.getDestObject(x2 ,y2,d);
		
			if(destId != 0){
			
				//主人公の方向
				playerDirection = d;
				//オブジェクトに攻撃
				this.atackObject(destId);	
			}
		
		}

	};

	//周囲の判定
	Game_Player.prototype.checkRoundDestObject = function(x,y,d)
	{

		for(var s = 0; s <= 315 ; s += 45){
		
			var rad =  s * Math.PI / 180;
			
			var SIN = Math.round(Math.sin(rad)) ;
			var x1 = x + SIN;
			
			var COS = Math.round(Math.cos(rad)) ;
			var y1 = y - COS;
			
			//指定座標のマップＩＤの取得
			var destId = $gameMap.eventIdXy(x1,y1);
			
			if(destId != 0){
			
				//主人公の方向
				playerDirection = d;
				//オブジェクトに攻撃
				this.atackObject(destId);
				
			}
			
		}


	};

	//前方5方向の判定
	Game_Player.prototype.checkFiveDestObject = function(x,y,d)
	{


		var x2 = x;
		var y2 = y;
	
		//x,y軸方向の当たり判定の拡張
		for(var i = -2  ;i <= 2 ; i++){
		
			if(d == 2 || d == 8){
				x2 = x + i;
			}
			if(d == 4 || d == 6){
				y2 = y +i;
			}
		
		
			var destId = this.getDestObject(x2 ,y2,d);
		
			if(destId != 0){
			
				//主人公の方向
				playerDirection = d;
				//オブジェクトに攻撃
				this.atackObject(destId);	
			}
		
		}

	};

	

	//破壊活動の実行
	Game_Player.prototype.atackObject = function(eventId){

		
			//接触フラグを降ろす
			this._destContactFlag = false;

			//耐久値の取得
			var events = $gameMap.event(eventId);
			var durable = events.destDurable();
			//ページ番号を取得
			var page = events.pageIndex();
			var c_anim = 1;
		
			//オブジェクトの耐久値が存在していて、
			if(durable > 0){
		
				//攻撃力よりも大きかったら実行
				//if(durable <= _Hyper_Manager.power){
				//ページ番号が１（破壊可能）なら
				if(page == 1){
					//攻撃成功
					c_anim = 2;
				
				}
				else{
			
					//攻撃力が低かったら
					//クリティカル処理
					if(this.checkCritical()){
					
						//攻撃成功
						c_anim = 3;
				
					
					}
					else{
						
						//前方のイベントの場合失敗アクション
						if(this.checkFlontObject(events)){
							//攻撃失敗
							c_anim = 1;
						}
						else{
							c_anim = 0;
						}
					}
				
			
				}
		
				//コモンイベントの実行
				destroyObject(c_anim,eventId);

				//アニメーション変数が１以上（破壊処理）の時にオブジェクトを破壊
				if(c_anim > 1){
			
						this.destObject(eventId,durable);
			
				}
			


			
			}
	};

	//オブジェクト前方判定
	Game_Player.prototype.checkFlontObject = function(events){
		//var px = player
		var x = getFrontPositionX(this._x,this._direction);
		var y = getFrontPositionY(this._y,this._direction);
		var ex = events._x;
		var ey = events._y;
		if(x == ex && y == ey){
			return true;
		}
		else{
				return false;
		}

	}
	
	//オブジェクト破壊実行
	Game_Player.prototype.destObject = function(eventId,durable){
	
			var events = $gameMap.event(eventId);
	
			//キーのセッティング
			this.setSwitch(eventId);
			//オブジェクト座標を飛ばす
			var character = _Game_Interpreter.character(eventId);
			
			//凍らせるオブジェクトはそのまま
			if( events.destType() != 2){ 
				//console.log("kesita");
				//character.locate(-1,-1);
			}

			
			_Hyper_Manager.destroyObject(durable);//テンション
			_Onomatope.set(playerCanvasX(this.x),playerCanvasY(this.y),this._direction);//擬音
					
			//エフェクトの発動
			this.effectObject(eventId);
			
			//スクリーンを変える
			Change_S_C();
			
	};
	
	//セルフスイッチをパラメータごとにセット方法を変える
	Game_Player.prototype.setSwitch = function(eventId){
		var events = $gameMap.event(eventId);
	
		//親番号がセットされていなければ取得したイベントを切り替える
		if(events.destParents() == 0){
		
			//var max = objectChild[eventId];
			var max = events.destChild();
			
			//分裂するものの子は無視する
			if(events.destType() == 3 || events.destType() == 4 || events.destType() == 5){
				max = 0;
			}
		
			//子を持っている分だけ繰り返す
			for(var i = 0 ; i <= max ; i++){ 
				
				//ThisMapSelfSwichesSet("A",eventId + i);
				ObjectDelete(eventId + i);
				
			}
			
		}
		else{
			//セットした親のセルフスイッチを切り替える
			this.setSwitch(events.destParents());
		}
		
	};
	
	//クリティカルの判定
	Game_Player.prototype.checkCritical = function(){
	
		return Math.round(Math.random() * 100) < _Hyper_Manager.returnCritical();
	
	};

	//効果付きオブジェクトの発動(0 = ノーマル、1 = 爆発)
	Game_Player.prototype.effectObject = function(eventId){
		
		var events = $gameMap.event(eventId);
		var type = events.destType();
	
		switch(type){
		case 1:
			//爆発
			events.destTypeRiset();
			
			this.effectExplosion(this._direction);
			break;
		case 3:
			//分裂するもの親
			this.playDivision(eventId,4);
			break;
		case 4:
			//分裂するもの子
			this.playDivision(eventId,5);
			break;
		case 5:
			//分裂するもの孫
			this.playDivision(eventId,0);
			break;
		}
	
	
	};
	
	//爆発エフェクト
/*	Game_Player.prototype.effectExplosion = function(d){
	
		var x = getFrontPositionX(this.x,playerDirection);
		var y = getFrontPositionY(this.y,playerDirection);		
	
		for(var s = 0; s <= 315 ; s += 45){
		
			var rad =  s * Math.PI / 180;
			
			var SIN = Math.round(Math.sin(rad)) ;
			var x1 = x + SIN;
			
			var COS = Math.round(Math.cos(rad)) ;
			var y1 = y - COS;
			
			//指定座標のマップＩＤの取得
			var eventId = $gameMap.eventIdXy(x1,y1);
			
			if(eventId != 0){
				
				this.destObject(eventId,0);
				
			}
			
		}
		//爆発アニメーション
		destroyObject(4,eventId);
	
	}
*/

	//破壊するイベントの取得
	Game_Player.prototype.getDestObject = function(x,y,d){
		
  		switch (d) {
    	case 1:    
      		return $gameMap.eventIdXy(x - 1, y + 1);
      		break;
    	case 2:
      		return $gameMap.eventIdXy(x + 0, y + 1);
     		 break;
    	case 3:
      		return $gameMap.eventIdXy(x + 1, y + 1);
      		break;
    	case 4:
      		return $gameMap.eventIdXy(x - 1, y + 0);
      		break;
    	case 5:
      		return $gameMap.eventIdXy(x + 0, y + 0);
      		break;
    	case 6:
     		 return $gameMap.eventIdXy(x + 1, y + 0);
      		break;
    	case 7:
      		return $gameMap.eventIdXy(x - 1, y - 1);
      		break;
    	case 8:
     		return $gameMap.eventIdXy(x + 0, y - 1);
      		break;
    	case 9:
      		return $gameMap.eventIdXy(x + 1, y - 1);
      		break;
    	}
   		 return 0;
	};

	//分裂、typeのイベントを生成
/*	Game_Player.prototype.playDivision = function(eventId,type){

			//新しくイベントを生成し、タイプを子にする
			var x = this._x;
			var y = this._y;

			this.divisionPositionSpaw(x,y,playerDirection,1,eventId,type);
			this.divisionPositionSpaw(x,y,playerDirection,-1,eventId,type);

			//元イベントの削除
			$gameMap.eraseEvent(eventId);


	}

	//分裂するもの親
	Game_Player.prototype.playDivisionParents = function(eventId){


			//新しくイベントを生成し、タイプを子にする
			var x = this._x;
			var y = this._y;

			this.divisionPositionSpaw(x,y,playerDirection,1,eventId,4);
			this.divisionPositionSpaw(x,y,playerDirection,-1,eventId,4);
	};
    
    //分裂するもの子
    Game_Player.prototype.playDivisionChild = function(eventId){
    		//新しくイベントを生成し、タイプをノーマルにする
			var x = this._x;
			var y = this._y;

			this.divisionPositionSpaw(x,y,playerDirection,1,eventId,0);
			this.divisionPositionSpaw(x,y,playerDirection,-1,eventId,0);
    	
			
	};
	
	//分裂する場所(生成)
	Game_Player.prototype.divisionPositionSpaw = function(x,y,d,rate,eventId,type){
		
		var character = _Game_Interpreter.character(eventId);
		var num = $gameVariables.value(30);
		$gameVariables.setValue(30,num + 1);

		
		var x1;
		var y1;
		switch(d){
		case 2:
			x1 = x + 1 * rate;
			y1 = y + 1;
			break;
		case 4:
			x1 = x - 1;
			y1 = y + 1 * rate;
			break;
		case 6:
			x1 = x + 1;
			y1 = y + 1 * rate;
			break;
		case 8:
			x1 = x + 1 * rate;
			y1 = y - 1;
			break;
		}
		
		//移動座標にオブジェクトがなければ生成
		if($gameMap.eventIdXy(x1,y1) == 0){
		var newEventId = $gameMap.spawnEvent(eventId,x1,y1,0);
		var events = $gameMap.event(newEventId);

		//タイプチェンジ
		events.destTypeChange(type);
			
		}


	
	}
	*/
    
    //=====================
	//テンションを管理するオブジェクト
	//====================
	
	function Hyper_Manager(){
		this.initialize.call(this);
	}
	
	Hyper_Manager.prototype.initialize = function(){
		this.value = hyperLevel_value;
		
		this.power = 1;//攻撃力
		this.level = 1;//現在のテンションレベル
		
		this.hyper = 0;//テンション値
		this.hyper_max = level_date[this.level - 1].exp; //テンション最大値
		
		this.flam = 0;
		this.decflam = 180;//テンションを下げるフレームタイミング
		//this.gauge_rate_y = 100.0;//ゲージの拡大率
		
		this.critical = 10;//クリティカル率（パーセント）
		
		this.combo = 0;//コンボ
		this.comonoFlame = 0;//コンボのフレームカウント

		this.spdCount = 0;//速度カウント
		
	};
	
	//リセット
	Hyper_Manager.prototype.set = function(){
	
		this.level = 1;
		this.hyper = 0;
		this.power = 1;
		this.hyper_max = level_date[this.level - 1].exp;
		this.flam = 0;
		this.critical = 10;
		this.combo = 0;
		this.comnoFlame = 0;
		$gameVariables.setValue(this.value,this.level);
		this.objectCount = 0;//破壊したオブジェクトを加算
		//クリア変数の初期化
		$gameSwitches.setValue(valueSwitchCria,false);
		$gameVariables.setValue(valueCria,0);

		this.spdCount = 0;
	
	
	};
	
	//攻撃力の上昇
	Hyper_Manager.prototype.powerUp = function(){
	
		this.power = pow_date[this.level - 1].pow;
		
	};
	
	//レベルアップ
	Hyper_Manager.prototype.hyperLevelUp = function(){
	
		if(this.hyper >= this.hyper_max && this.level < 8){
			if(this.level < maxHyper){
				this.level += 1;
				var rest_exp = this.hyper - this.hyper_max;
				this.hyper_max = level_date[this.level - 1].exp;
				this.hyper = 0;
				$gameVariables.setValue(this.value,this.level);
				//se
				AudioManager.playSe({"name":"Devil2","volume":100,"pitch":100,"pan":0});
			}
			this.powerUp();			
		}
	};

	//ステージ４の実行
	Hyper_Manager.prototype.stage4 = function(){
//		$gameSystem.wolfSetScale(this.level);
		var scale = Math.floor($gameVariables.value(valueCria) / 5) * 0.625 + 1 //スケールの計算（破壊率5%ごとに、　0.625　分加算していく）
		$gameSystem.wolfSetScale(scale);
	}
	
	//増やす
	Hyper_Manager.prototype.addHyper = function(add){
		
		this.hyper += add;

		if(this.hyper > this.hyper_max) this.hyper = this.hyper_max;
		
		this.hyperLevelUp();
		
	};
	
	//減らす
	Hyper_Manager.prototype.decHyper = function(){
		this.flam += 1;
		if(this.flam >= this.decflam){
		
			this.hyper -= 1;
			if(this.hyper < 0) this.hyper = 0;
			
			
			this.flam = 0;
			
		}
	}

	//破壊したオブジェクトをカウントする
	Hyper_Manager.prototype.addObjectCount = function(add){
		this.objectCount += add;
		//破壊率を計算してメインに渡す
		var rate = this.objectCount / testMaxObject * 100;
		$gameVariables.setValue(valueCria,rate);
	}

/*
	//テストフェイス画像
	var face_name = new Array();
	
	for(var i = 1 ; i <= 5 ; i++){
		face_name[i] = "Baby_Mark_0" + i;
	}
	
	//ゲージの表示
	Hyper_Manager.prototype.createGauge = function(){
		//$gameScreen.showPicture(hyperPicId,face_name[this.level],0,20,456,75.0,75.0,255,0);

	};
	*/

	//テンションメータの描画
	Hyper_Manager.prototype.drawMeter = function(){
		//主人公と重なったら透明化
		var opp = 255;
		if($gamePlayer.screenY() >= 624 - 250 && $gamePlayer.screenX() <= 250){
			opp = 100;
		
		}
		
		$gameScreen.showPicture(hyperPicId,"Unite_PutMeterBack",1,105,509,75.0,75.0,opp,0);
		$gameScreen.showPicture(hyperPicId + 1,"Unite_PutMeter",1,105,585,75.0,75.0,opp,0);
		var rate = (this.level - 1 ) / maxHyper;
		var angle = rate  * -180;
		angle = Math.max(-145 , angle);
		$gameScreen.picture(hyperPicId + 1).changeAngle(angle);

	}
	
	//コンボの加算
	Hyper_Manager.prototype.addCombo = function(){
	
		this.combo += 1;
		this.comboFleam = 0;
		$gameVariables.setValue(combo_value,this.combo);
	
	}
	
	//コンボ
	Hyper_Manager.prototype.comboCount = function(){
	
		//コンボがあればカントしていく
		if(this.combo > 0){
			this.comboFleam += 1;
			
			if(this.comboFleam >= 120){
				this.combo = 0;
				this.risetCritical();
				
				$gameVariables.setValue(combo_value,this.combo);
				$gameVariables.setValue(critical_value,this.critical);
				
			
			}
		}
	};

	//コンボをDTextで表示
	Hyper_Manager.prototype.drawCombo = function(){
		var comboStr = this.combo.toString(10) + 'コンボ！';
		$gameScreen.setDTextPicture(comboStr,42);
		$gameScreen.showPicture(30,"",0,580,88,100.0,100.0,255,0);
	};
	
	//クリティカルの加算
	Hyper_Manager.prototype.addCritical = function(){
	
		this.critical += 5;

		if(this.critical > 100){this.critical = 100;}
		
		$gameVariables.setValue(critical_value,this.critical);
	
	};
	
	Hyper_Manager.prototype.risetCritical = function(){
	
		this.critical = 10;
	
	};
	
	//クリティカル率をDTextで表示
	Hyper_Manager.prototype.drawCritiacl = function(){
		var criticalStr = 'Critical ' + this.critical.toString(10) + '%';
		$gameScreen.setDTextPicture(criticalStr,32);
		$gameScreen.showPicture(31,"",0,580,138,100.0,100.0,255,0);
	};


	//クリティカルを返す
	Hyper_Manager.prototype.returnCritical = function(){
		return this.critical;
		
	
	};
	
	//オブジェクトの破壊時に呼ばれる
	Hyper_Manager.prototype.destroyObject = function(add){
	
		this.addHyper(add);
		this.addCombo();
		this.addCritical();
		this.addObjectCount(1);

		//ステージ4の時、でサイズ変更
		if($gameVariables.value(valueStage) == 4){
			this.stage4();
		}
		
	}

	//クリア判定
	Hyper_Manager.prototype.checkCria = function(){
		var stage = $gameVariables.value(valueStage);
		switch(stage){
			case 1:
				this.criaStage1();
				break;
			case 2:
				this.criaStage2();
				break;
			case 3:
			//	this.criaStage3();
				break;
			case 4:
				this.criaStage4();
				break;
			case 5:
				//this.criaStage5();
				break;
			case 6:
				//this.criaStage6();
				break;
			case 7:
				//this.criaStage7();
			}
		
	}

	//ステージごとにクリア条件を変える
	Hyper_Manager.prototype.criaStage1 = function(){
		if($gameVariables.value(valueCria) >= 50){
			$gameSwitches.setValue(valueSwitchCria,true);
		}
		
	}

	Hyper_Manager.prototype.criaStage2 = function(){
		//モバイル時にクリア数値の変更
		var criaval = 80;
		if(isMobile) criaval = 60;
		if($gameVariables.value(valueCria) >= criaval){
			$gameSwitches.setValue(valueSwitchCria,true);
		}
		
	}

	Hyper_Manager.prototype.criaStage4 = function(){
	//	if($gameSystem.wolfGetScale() >= 5){
		//モバイル時にクリア数値の変更
		var criaval = 80;
		if(isMobile) criaval = 60;
		if($gameVariables.value(valueCria) >= criaval){
			$gameSwitches.setValue(valueSwitchCria,true);
		}

		
	}

	Hyper_Manager.prototype.criaStage5 = function(){
		if($gameVariables.value(valueCria) >= 50){
			$gameSwitches.setValue(valueSwitchCria,true);
		}
		
	}

	Hyper_Manager.prototype.criaStrStage = function(){
		var stage = $gameVariables.value(valueStage);
		var str = "";
		switch(stage){
			case 1:
				str = '破壊率：' + $gameVariables.value(valueCria).toString(10) + ' %';		
				break;
			case 2:
				str = '破壊率：' + $gameVariables.value(valueCria).toString(10) + ' %';		
				break;
			case 3:
			//	this.criaStage3();
				break;
			case 4:
				str = '破壊率：' + $gameVariables.value(valueCria).toString(10) + ' %';		
				break;
			case 5:
				var sec = $gameTimer.seconds();
				var isTime = $gameTimer.isWorking();
				if(isTime == true && sec <= 0){
					$gameSwitches.setValue(8,true);
					$gameSwitches.setValue(1,false);
					$gameTimer.stop();

				}
				break;
			case 6:
				str = '救出：' + $gameVariables.value(31).toString(10) + ' / 16人';		
				break;
			case 7:
				str = '消臭率：' + $gameVariables.value(16).toString(10) + ' %';		
				break;
			case 8:
				str = '破壊：' + $gameVariables.value(32).toString(10) + ' 個';		
				break;
		}
		return str;
	};

	//クリア条件をDTextで表示
	Hyper_Manager.prototype.drawCria = function(){
		var criaStr = '破壊率：' + $gameVariables.value(valueCria).toString(10) + ' %';
		var criaStr = this.criaStrStage();
		$gameScreen.setDTextPicture(criaStr,42);
		$gameScreen.showPicture(40,"",0,0,88,100.0,100.0,255,0);
	};


	Hyper_Manager.prototype.updateAnimeFleam = function(){
		animFleam = Math.max(animFleam - 1 , 0);
	}
	
	//主人公の速度を時間によって戻す
	Hyper_Manager.prototype.updateSpdCount = function(){

		if($gameSwitches.value(6)){//速度アップのスイッチ
			this.spdCount += 1;
			if(this.spdCount == 60){
				$gameTemp.reserveCommonEvent(15);//速度を戻す処理
			}
			//180フレームで速度アップスイッチをオフにする
			if(this.spdCount > 180){
				this.spdCount = 0;
				$gameSwitches.setValue(6,false);
			}
		}

	};

	Hyper_Manager.prototype.update = function(){
	
		//this.createGauge();
		this.comboCount();
		this.updateAnimeFleam();
		this.drawMeter();
		this.drawCombo();
		this.drawCritiacl();
		this.drawCria();
		this.checkCria();
		this.updateSpdCount();

	};
	
	//=====================-
	//擬音表示
	//=====================-
	
	function Onomatope(){
	
		this.initialize.call(this);
	
	}
	
	Onomatope.prototype.initialize = function(){
	
		this._act = false;
		this._count = 0;
	
		this._x = 0;
		this._y = 0;
		this._dire = 0;
		
		this._picId = 20;
	//	this._picName = ["BAKI","BABU","DOKA"];
		this._picName = "ONO_";
		this._picMax = 10; //擬音画像の数
		this._picNum = 0;//ランダム表示させる画像の番号
		this._picBiforNum = 1;//ランダム表示させた番号を取得
		
		this._scale = 50.0;
		
		
	
	};
	
	Onomatope.prototype.set = function(x,y,d){
	
		this._act = true;
		this._count = 0;
		this._drawFleam = 60;

		this._dire = d;
		this._x = x;
		this._y = y;
		
		do{
			this._picNum = Math.floor(Math.random() * this._picMax);
		}while(this._picNum == this._picBiforNum);
		this._picBiforNum = this._picNum;
			
		this.direChange();
		
		this.draw();
		
	};
	
	//更新
	Onomatope.prototype.update = function(){
	
		if(this._act){
		
		
			this._count += 1;
			
			
			//一定時間で削除
			if(this._count >= this._drawFleam){
				this.delete();
				
			} 
		
		}
	
	};
	
	
	Onomatope.prototype.draw = function(){
		//console.log("x2 = " + this._x);
		var fileName = this._picName + String(this._picNum);
		$gameScreen.showPicture(this._picId,fileName,1,this._x,this._y,this._scale,this._scale,255,0);
	};
	
	Onomatope.prototype.delete = function(){
	
		$gameScreen.erasePicture(this._picId);
		this._act = false;
	
	};
	
	
	Onomatope.prototype.direChange = function(){
	
	
		var addX = $gameMap.tileWidth() * 2;
		var addY = $gameMap.tileHeight() * 2 * -1;
		
		if(this._dire == 2){
			addY = 0;
		}
		
		if(this._dire == 1){
			addX = -150;
		}
		
		if(this._dire == 4){
			addX = 50;
		}
		
		this._x += addX;
		this._y += addY;

		
	}
	

	//===========-
	//イベントキャラクター
	//===========
	
	
	//更新追加定義
	var _Game_Event_update = Game_Event.prototype.update;
	Game_Event.prototype.update = function(){
		_Game_Event_update.call(this);
		
		if(this._destObjectCount > 0){
	
			this._destObjectCount -= 1;
	
			//カウントが０になったらそれぞれの効果を実行
			if(this._destObjectCount == 0){
				this.playEnemyType(this._destType);
			}
	
		}
	};
	
	//敵の種類によって操作を変える
	Game_Event.prototype.playEnemyType = function(type){
	
		switch(type){
		case 7:
			this.overFlowing();
			break;
		}
	
	};

/*	
	//溢れ出るもの実行
	Game_Event.prototype.overFlowing = function(){
		
		var events = $gameMap.event(this._eventId + 1);
		if(events.destDurable() == 0){
			this._destObjectCount = dcount_data[this._destType].count;
   			ThisMapSelfSwichesSet("B",this._eventId + 1);
   			ThisMapSelfSwichesRiset("A",this._eventId + 1);
   		
   			//移動
   			var character = _Game_Interpreter.character(this._eventId + 1);	
   			var x = getFrontPositionX(this._x,this._direction)
   			var y = getFrontPositionY(this._y,this._direction)
			character.locate(x,y);
   		
   			events.destDurableChange(1);
		}
	
	};
	*/
	//イベント現在のページ番号を返す
	Game_Event.prototype.pageIndex = function() {
    	return this._pageIndex;
	};
	
	
	Game_Event.prototype.isCollidedWithEvents = function(x, y) {
   
    var events = $gameMap.eventsXyNt(x, y);
    
    //追加定義、接触したら実行
    if(events.length > 0){
    	
    	var eventId = events[0].eventId();
    	//console.log("ivent = " +eventId);
    	var events2 = $gameMap.event(eventId);
    	//接触したオブジェクトが凍らせるオブジェクトなら
    	if(events2.destType() == 2){
    		this.ice(events2);
    		
    	}
    	//貪るもの
    	if(this.destType() == 6){
    		this.covet(eventId);
    	}
    
    }

    //ホーリーイベントだけ別で判定
    var eventIdHory = $gameMap.eventIdXy(x,y);
    var eventsHoly = $gameMap.event(eventIdHory);
    //聖水なら
    if(eventsHoly){
    	if(eventsHoly.destType() == 8){
    		this.holyWater(eventsHoly);
    	}
    }

    return events.length > 0;

	};
	
	/*
	//凍らせるオブジェクト
	Game_Event.prototype.ice = function(events){
   		//ページ番号を参照して１の時に凍る
   		var page = events.pageIndex();
   		if(page == 1){
   			//se
			AudioManager.playSe({"name":"Ice4","volume":100,"pitch":100,"pan":0});
   			ThisMapSelfSwichesSet("B",this._eventId);
   			
   			events.destDurableChange(1);	
   		}
	};
	*/
	//聖水オブジェクト（最後の戦い）
	Game_Event.prototype.holyWater = function(events){
   		//ページ番号を参照して１の時に凍る
   		var page = events.pageIndex();

   		if(page == 2){
   			//se
			AudioManager.playSe({"name":"Magic2","volume":100,"pitch":100,"pan":0});
   			//ThisMapSelfSwichesSet("B",this._eventId);
   			//console.log("holy");
			//コモンイベントの実行クソファーのノックバック
			$gameTemp.reserveCommonEvent(19);

   			//events.destDurableChange(1);	
   		}
	};

	Game_Event.prototype.covet = function(eventId){

		var events = $gameMap.event(eventId);
		
		if(events.destDurable() > 0){
			//キーのセッティング
			this.setSwitch(eventId);
			events.destDurableRiset();
			
			//オブジェクト座標を飛ばす
			var character = _Game_Interpreter.character(eventId);		
			//凍らせるオブジェクトはそのまま
			if(events.destType() != 2){
				character.locate(-1,-1);
			}
		}
		
	};
	
	//セルフスイッチをパラメータごとにセット方法を変える
	Game_Event.prototype.setSwitch = function(eventId){
	
		var events = $gameMap.event(eventId);
		
		//親番号がセットされていなければ取得したイベントを切り替える
		if(events.destParents() == 0){
			var max = events.destChild();
			
			//分裂するものの子は無視する
			if(events.destType() == 3 || events.destType() == 3 || events.destType() == 5){
				max = 0;
			}
		
			//子を持っている分だけ繰り返す
			for(var i = 0 ; i <= max ; i++){ 
				
				ObjectDelete(eventId + i);
				
			}
			
		}
		else{
			//セットした親のセルフスイッチを切り替える
			this.setSwitch(objectParents[eventId]);
		}
		
	};
	

    
    //============================
	//Scene_Map の再定義
	//マップを作った時に破壊可能オブジェクトの耐久値をリセット
	//============================
	
	var _Scene_Map_create = Scene_Map.prototype.create
	Scene_Map.prototype.create = function() {
		_Scene_Map_create.call(this);
		

		if(this._transfer){
    		//this.resetDest();
    		_Hyper_Manager.set();
			$gameVariables.setValue(smoke_value,smoke_proba);//煙確率
		}
		

    	
	};
		
	var _Scene_Map_start = Scene_Map.prototype.start;
	Scene_Map.prototype.start = function() {
	_Scene_Map_start.call(this);
    	//イベントの移動等に使用するインスタンスのマップIDを現在のマップに設定
		var mapid = $gameMap.mapId();	
		_Game_Interpreter._mapId = mapid;


      	//イベントの数を計算
        testMaxObject = countArray($dataMap.events);

		//ノート読み込み,デストゲームマップならスイッチオン
        var note = $dataMap.note;
		if(note){
			if(note === 'destGame'){
				$gameSwitches.setValue(1,true);
				//var stage = getStage($gameMap.mapId());
				stageNum = getStage($gameMap.mapId());
				$gameVariables.setValue(valueStage,stageNum);
				maxHyper = maxHyper_data[stageNum - 1].max;//テンションの最大値を設定
				//アニメーション画像のロード
				loadAnimationPictures();


			}
		}else{
				$gameSwitches.setValue(1,false);//そうでなければフラグを降ろす
		}
	};
	
	//=============================================================================
    // Game_Event
    //  イベントから note を取得して耐久値のセットを行う
    //=============================================================================



	//デストシステムの変数をイベントに追加
	Game_Event.prototype.desSysValues = function(){
	
		//耐久値
		this._destDurable = 0;
		//タイプ
		this._destType = 0;
		
		//親
		this._destParents = 0;
		
		//子供
		this._destChild = 0;
		
		//デストオブジェクトが使用するカウント
    	this._destObjectCount = 0;
    	
	};
	
	//耐久値を返す
	Game_Event.prototype.destDurable = function(){
		return this._destDurable;
	};
	//タイプを返す
	Game_Event.prototype.destType = function(){
		return this._destType;
	};
	//親を返す
	Game_Event.prototype.destParents = function(){
		return this._destParents;
	};
	//子供を返す
	Game_Event.prototype.destChild = function(){
		return this._destChild;
	};
	//耐久値を返す
	Game_Event.prototype.destObjectCount = function(){
		return this._destObjectCount;
	};
	
	//耐久値を0にする
	Game_Event.prototype.destDurableRiset = function(){
		this._destDurable = 0;
	};
	//耐久値を変える
	Game_Event.prototype.destDurableChange = function(change){
		this._destDurable = change;
	};
	
	//タイプを０にする
	Game_Event.prototype.destTypeRiset = function(){
		this._destType = 0;
	};
	//タイプを変える
	Game_Event.prototype.destTypeChange = function(change){
		this._destType = change;
	};



	var _Game_Event_DesSysValue = Game_Event.prototype.desSysValues;

    var _Game_Event_initialize = Game_Event.prototype.initialize;
    Game_Event.prototype.initialize = function(mapId, eventId) {
    _Game_Event_initialize.apply(this,arguments);
    
    	//追加変数
    	this.desSysValues();
    
    
            var note = this.event().note;
            if (note) {

            	var durable_level = 1;
            	var object_type = 0;
            	var object_parents = 0;
            	var object_child = 0;
                note.toUpperCase().replace(/\\D(\d+)/, function() {durable_level = parseInt(arguments[1],10)}  );
                note.toUpperCase().replace(/\\T(\d+)/, function() {object_type = parseInt(arguments[1],10)}  );//タイプのセット
                note.toUpperCase().replace(/\\P(\d+)/, function() {object_parents = parseInt(arguments[1],10)}  );//親のセット
                note.toUpperCase().replace(/\\C(\d+)/, function() {object_child = parseInt(arguments[1],10)}  );//子のセット
            	
            	this._destDurable = durable_data[durable_level].durable;
            	
            	this._destType = object_type;
            	
            	this._destParents = object_parents;
            	
            	this._destChild = object_child;
            	
            	this._destObjectCount = dcount_data[this._destType].count;//オブジェクトに使用するカウントのセット（通常は０）
            	
            	//子は親の耐久値を引き継ぐ
            	if(object_parents > 0){
            		 var events = $gameMap.event(this._destParents);
            		 this._destDurable = events._destDurable;
            	}
            }
            
	};

	
	//====================================-
	//オブジェクト生成
	//====================================-
	
	//テンションゲージマネージャー
	var _Hyper_Manager = new Hyper_Manager();
	//擬音
	var _Onomatope = new Onomatope();
	//
	var _Game_Interpreter = new Game_Interpreter();
	
	
	//==================================--
	//シーンのアップデート（すべてのオブジェクトのアップデート）
	//==================================--
	var _Scene_Map_update = Scene_Map.prototype.update;
	Scene_Map.prototype.update = function() 
	{
		_Scene_Map_update.call(this);	
	
		if($gameSwitches.value(1)){
			_Hyper_Manager.update();
			_Onomatope.update();
		}
		
	};
	
	

})();


