﻿//----------------------------------------------------------------
// Varsion
// 0.4.0 2016_12_11 基本系統の作成
//					UIの配置
//					ボタンの作成
//					コマンドの表示
//					入力コマンドの作成
//					アクション実行
// 0.4.1 2016_12_13 WolfGame_Base 変更に伴い、ピクチャの最大、最小の変数を削除
//					グッド、バッドエフェクトの追加
// 0.4.3 2016_12_14 SEの追加
//					BGMの追加
//
//----------------------------------------------------------------
/*:ja
*@plugindesc クソファーとの決闘
*@author うるふ
*
*@param Unknown Date
*@desc プロトタイプ
*default 不明
*
*@help
*
*クソファーとの決闘
*
*
*
*/



(function() {

	//==================================
	//オブジェクト生成
	//==================================

	function WolfGame_Duel(){
		this.initialize.call(this);
	}

	//ゲームベースを継承
	WolfGame_Duel.prototype = Object.create(WolfGame_Base.prototype);
	WolfGame_Duel.prototype.constructor = WolfGame_Duel;


	//==================================
	//変数
	//==================================



	//==================================
	// プラグインパラメータ取得
	//==================================

	//パラメータ取得するときに使用
	var Parameters = PluginManager.parameters('Wolf_DuelGame');

	//=======================================
	// WolfGame_Duel メソッド
	//=======================================

	//=============================-
	// ゲーム基本メソッド
	//=============================-

	WolfGame_Duel.prototype.initialize = function(){
		WolfGame_Base.prototype.initialize.call(this);
	//	this._minPicId = 1;
	//	this._maxPicId = 25;

		this._gameMap = 37;//実行マップ
		this._actionEvent = 7;//並列アクション実行イベントＩＤ
		this._actionChangeValueNum = 21;//アクション切り替え変数番号

		this._buttonNum = 0;//ボタン入力番号、Ben = 1 , Sei = 2 , Shi = 3 , Bah = 4
		this._buttonName = [ "Ben" , "Sei", "Shi" , "Bah"];

		//this._buttonOffFram = 2;//ボタン保持フレーム
		//this._buttonOffCount = 0;

		this._positionB = [ [0,0],
							[0,0],
							[0,0],
							[0,0] ];//ボタンの座標

		this._command = [ 	[1,2,3,4],
							[1,2,3,4,1],
							[1,2,3,4,4,3,2,1] ];//コマンド

		this._inputCommand = [ ]//入力コマンドを保持


		this._commandIndex = 0;
		this._commandDilayFram = 4;//コマンド表示のディレイフレーム数 
		this._commandDilayCount = 0; 

		this._scene = 0; //進行のシーン

		//this._commandQuan = 4;//コマンドの数
		//this._commandCount = 0;

		//this._Common01 = 26;

		//se file name
		this._seGood = "Item3";
		this._seMiss = "Disappointment";
		this._seVeryGood = "correct1";
		this._seButton = "Cancel2";

		//bgm file name
		this._bgm = "Battle2";

	}

	//==========================
	// 変数初期化
	//==========================

	WolfGame_Duel.prototype.risetAll = function(){
		this.risetButton();
		this.risetCommand();
		this.risetSceneValue();
		this.risetActionValue();
	}

	WolfGame_Duel.prototype.risetCommand = function(){
		this._commandCount = 0;
		this._commandIndex = -1;
		this._commandDilayCount = 0;
		this._inputCommand = [ ]//入力コマンドを保持


	}

	WolfGame_Duel.prototype.risetButton = function(){
		for(var i = 0 ; i < 4 ; i++){
			this._positionB[i][0] = 15 + 90 * ( i + 1) + 22 * i + 90 * i;
			this._positionB[i][1] = 624 - 90 - 30;
		}
	}

	WolfGame_Duel.prototype.risetActionValue = function(){
		$gameVariables.setValue(this._actionChangeValueNum,0);
	}

	WolfGame_Duel.prototype.risetSceneValue = function(){
		this._scene = 0;
	}

	WolfGame_Duel.prototype.set = function(){
		WolfGame_Base.prototype.set.call(this);
		WolfGame_Base.prototype.playBgm.call(this,this._bgm);
		this.risetAll();
		this.draw();
	};


	WolfGame_Duel.prototype.main = function(){
		WolfGame_Base.prototype.main.call(this);
		
		if(this.isUpdate()){
			this.update();
		}
		this.draw();


	};

	WolfGame_Duel.prototype.end = function(){
		WolfGame_Base.prototype.end.call(this);
	}

	//=============================-
	// ゲーム更新関係
	//=============================-

	WolfGame_Duel.prototype.update = function(){

		this.checkButton();
		this.inputCommand();
		this.upCommandIndex();

	}

	WolfGame_Duel.prototype.checkButton = function(){
		this.checkButtonTouch();
		this.checkButtonKey();
	}

	WolfGame_Duel.prototype.checkButtonTouch = function(){
		if(TouchInput.isPressed()){
		
			for(var i = 0 ; i < 4 ; i++){
				if($gameSystem.wolfIsCollisionCircleDot(this._positionB[i][0],this._positionB[i][1],180,180,TouchInput.x,TouchInput.y)){
					this._buttonNum = i + 1;

				}
			}
		}
	}

	//方向キーを取得し、ボタンと対応させる
	WolfGame_Duel.prototype.checkButtonKey = function(){
		var key = $gameSystem.wolfReturnIsPressedCursorKey()

		if(key != ""){
			this._buttonNum = this.changeKeytoButton(key);
		}
	}

	WolfGame_Duel.prototype.changeKeytoButton = function(KEY){
		var num = 0;
		if(KEY == "LEFT"){
			num = 1;
		}
		if(KEY == "RIGHT"){
			num = 4;
		}
		if(KEY == "UP"){
			num = 2;
		}
		if(KEY == "DOWN"){
			num = 3;
		}
		return num;
	}

	WolfGame_Duel.prototype.offButton = function(){
	
			this._buttonNum = 0;
	}

	WolfGame_Duel.prototype.inputCommand = function(){

		if(this._buttonNum != 0){
			var key = $gameSystem.wolfReturnIsPressedCursorKey(); //これがないとき
			var touch = TouchInput.isPressed();//これがfalseのとき

			if(touch == false && key == ""){
				this.addComand(this._buttonNum);
				this.offButton();
			}
		}
	}

	//コマンドを入力する
	WolfGame_Duel.prototype.addComand = function(command){
		//現在の入力コマンド数
		this._inputCommand.push(command);

		var num = this._scene;//現在のコマンド番号

		var xIndex = this._inputCommand.length - 1;//エフェクト座標x 計算
		//今入力したコマンドが正しければエフェクト
		if(this.checkInputCommand(command)){
			WolfGame_Base.prototype.criateMarkEffect.call(this,30 + 48 + 96 * xIndex,288 - 49,"GOOD");//エフェクト			
			WolfGame_Base.prototype.playSe(this._seGood);//SEの再生
		}else{
			WolfGame_Base.prototype.criateMarkEffect.call(this,30 + 48 + 96 * xIndex,288 - 49,"BAD");//エフェクト			
			WolfGame_Base.prototype.playSe(this._seMiss);//SEの再生
		}

		if(this._inputCommand.length >= this._command[num].length){

			//コマンドが正しいかチェック
			if(this.checkCommand(this._inputCommand,this._command[num])){
			
				this.playAction();
				this.forwardScene();
				WolfGame_Base.prototype.criateMarkEffect.call(this,408,312,"VERYGOOD");//エフェクト			
				WolfGame_Base.prototype.playSe(this._seVeryGood);//SEの再生


			}
			else{
				//終わらせず再度コマンド入力させる
				//WolfGame_Base.prototype.onEndSwitche.call(this);//とりあえず終了
			}


			this.risetCommand();//
		}
	}

	//今インプットされたコマンドが正しいかチェックする
	WolfGame_Duel.prototype.checkInputCommand = function(command){
		var num = this._inputCommand.length - 1;
		var index = this._scene;//現在のコマンド番号

		if(command == this._command[index][num]){
			return true;
		}
		else{
			return false;
		}

	}

	//マップ内並列イベントをオンにして実装
	WolfGame_Duel.prototype.playAction = function(){
		var key = [this._gameMap,this._actionEvent,"A"];
		$gameSelfSwitches.setValue(key,true);
	}

	//コマンドが正しいかチェックする
	WolfGame_Duel.prototype.checkCommand = function(input,command){
		var check = true;

		for(var i = 0 ; i < input.length ; i++){
			if(input[i] != command[i]){
				check = false;
			}
		}

		return check;
	}

	//ゲームを進める
	WolfGame_Duel.prototype.forwardScene = function(){
		
		//一旦ここで終わらせる、演出の関係で変わる可能性があるため
		if(this._scene + 1 >= this._command.length){
			WolfGame_Base.prototype.onEndSwitche.call(this);//コマンドがすべておわったら、とりあえず終了

		}

		this._scene = Math.min(this._scene + 1 , this._command.length - 1);
	};

	//アップデート可能時trueを返す
	WolfGame_Duel.prototype.isUpdate = function(){

		var key = [this._gameMap,this._actionEvent,"A"];
		
		if($gameSelfSwitches.value(key) == true){
			return false;
		}
		
		return true;

	};
/*
	//クリア
	WolfGame_Duel.prototype.onGameCria = function(){
		if(this._scene +1 >= this._command.length){
			WolfGame_Base.prototype.onEndSwitche.call(this);//とりあえず終了

		}
	}
*/


		WolfGame_Duel.prototype.upCommandIndex = function(){
	
		if(this._commandDilayCount <= 0){
			this._commandDilayCount = this._commandDilayFram;
			var num = this._scene;//現在のコマンド
			this._commandIndex = Math.min(this._commandIndex + 1 , this._command[num].length);//コマンドインデックスは現在のコマンドの長さ
		}else{
			this._commandDilayCount -= 1;
		}

	}

	//=============================-
	// ゲーム描画関係
	//=============================-

	WolfGame_Duel.prototype.draw = function(){
		WolfGame_Base.prototype.draw.call(this);
		this.drawBackCommand(1);
		this.drawBackButton(2);
		this.drawCommand(3); // 3 + 8
		this.drawButton(11);//11 + 4
		this.drawInputCommand(15);//15 + 8 
	}


	WolfGame_Duel.prototype.drawBackCommand = function(id){
		$gameScreen.showPicture(id,"Duel_BackCommand",0,0,0,100.0,100.0,255,0);

	}

	WolfGame_Duel.prototype.drawBackButton = function(id){
		$gameScreen.showPicture(id,"Duel_BackButton",0,0,624 - 240,100.0,100.0,255,0);

	}

	WolfGame_Duel.prototype.drawCommand = function(id){

		var charNum = 0;
		var num = this._scene;
		var fileName = "";

		for(var i = 0 ; i < this._commandIndex ; i++){

			charNum = this._command[num][i] - 1;
			fileName = "Duel_Command" + this._buttonName[charNum];

			$gameScreen.showPicture(id + i,fileName,0,15 + 98 * i,15 + 25.5,100.0,100.0,255,0);

		}
			

	};




	WolfGame_Duel.prototype.drawButton = function(id){

		var fileName = "";
		for(var i = 0 ; i < 4 ; i++){
			fileName = "Duel_Button" + this._buttonName[i];
			if(this._buttonNum == i + 1){ fileName += "Down" ;}
			$gameScreen.showPicture(id + i,fileName,1,this._positionB[i][0],this._positionB[i][1],100.0,100.0,255,0);
		}

	};

	WolfGame_Duel.prototype.drawInputCommand = function(id){

		var charNum = 0;
		var fileName = "";

		for(var i = 0 ; i < this._inputCommand.length ; i++){

			charNum = this._inputCommand[i] - 1;
			fileName = "Duel_Command" + this._buttonName[charNum];

			$gameScreen.showPicture(id + i,fileName,0,15 + 98 * i,288 - 49,100.0,100.0,180,0);	
		}
	}

	//=============================-
	// ゲーム終了関係
	//=============================-
	
	//=========================================
	//オブジェクト生成
	//=========================================
	var _WolfGame_Duel = new WolfGame_Duel();


	//=========================================
	// プラグインコマンドで制御
	//=========================================

	var _Game_Interpreter_pluginCommand = Game_Interpreter.prototype.pluginCommand;
	Game_Interpreter.prototype.pluginCommand = function(command,args)
	{
		_Game_Interpreter_pluginCommand.call(this,command,args);

		if(command === 'Wolf_DuelGame'){

			switch (args[0])
			{
			case 'set':
				_WolfGame_Duel.set();
				break;			

			case 'main':
				_WolfGame_Duel.main();
				break;
			case 'end':
				_WolfGame_Duel.end();
				break;			
	
			}
		}

	};
		




})();
