﻿//----------------------------------------------------------------
// Varsion
// 0.4.0 2017_02_05 基盤の完成
// 0.6.0 2017_02_06 演出以外のほとんどの機能を実装
//----------------------------------------------------------------
/*:ja
*@plugindesc 早食いゲーム
*@author うるふ
*
*@param Unknown Date
*@desc なし
*default 不明
*
*@help
*
*早食いゲーム
*
*
*
*/



(function() {

	//==================================
	//オブジェクト生成
	//==================================

	function Wolf_EatGame(){
		this.initialize.call(this);

	}


	//ゲームベースを継承
	Wolf_EatGame.prototype = Object.create(WolfGame_Base.prototype);
	Wolf_EatGame.prototype.constructor = Wolf_EatGame;


	//==================================
	//変数
	//==================================
	var objectMaxSize = 120;

	//オブジェクトの出現率(合計100) negi touhu niku mizu
	var objectSponRate = [29,27,15,29];
	//オブジェクトの出現率(タイムオーバー直前) negi touhu niku mizu
	var objectSponRateLast = [11,11,70,8];


	//==================================
	//食材オブジェクト
	//==================================

	function EatObject(){
		this.initialize.apply(this,arguments);
	}

	EatObject.prototype.initialize = function(x,y,type,dire,key){
		this._x = x;
		this._y = y;
		this._dire = (dire == 1 || dire == -1 ) ? dire : 1;//1　= 正の方向　-1　= 負の方向


		this._type = type;
		this._point = 0;
		this._atuatu = 0;
		this._fileName = "Eat_";
		this._width = 0;
		this._height = 0;

		this._tyingKey = key || 'ok';
		this._tyingKeyImgName = "Eat_Key";
		this._tyingKeyImgName += String(this._tyingKey);

		this.setType(this._type);

		this._y += this._height / 2;//下に加算
		this._y = Math.min(Graphics.height - 48 - this._height / 2,this._y);//下に行き過ぎないように修正(48 はUI値)

	};

	EatObject.prototype.setType = function(id){
		id = id || 0;
		switch(id){
			case 0:
				this._fileName += "NEGI";
				this._point = 10;
				this._atuatu = 100;
				this._width = 120;
				this._height = 120;
				break;
			case 1:
				this._fileName += "TOUHU";
				this._point = 50;
				this._atuatu = 500;
				this._width = 120;
				this._height = 100;
				break;
			case 2:
				this._fileName += "TORINIKU";
				this._point = 100;
				this._atuatu = 0;
				this._width = 80;
				this._height = 80;
				break;
			case 3:
				this._fileName += "MIZU";
				this._point = 0;
				this._atuatu = -500;
				this._width = 100;
				this._height = 180;
				break;
		}
	};



	//==================================
	// プラグインパラメータ取得
	//==================================

	//パラメータ取得するときに使用
	//var Parameters = PluginManager.parameters('Wolf_MiniGame');

	//=======================================
	// Wolf_EatGame メソッド
	//=======================================

	//=============================-
	// ゲーム基本メソッド
	//=============================-

	Wolf_EatGame.prototype.initialize = function(){
		WolfGame_Base.prototype.initialize.call(this);

		this._gameTopUIHeight = 96;
		this._gameScreenHeight = Graphics.height - this._gameTopUIHeight;

		this._setTimeValue = 21;
		this._setPointValue = 22;
	//	this._setAtuatuValue = 23;//テスト的

		this._objectSponRate = objectSponRate;

		this._maxAtuatu = 2000;

		this._bgm = "Quick_pipes";

		this._isMobile = false;//モバイル判定

		this.risetAll();

	};

	Wolf_EatGame.prototype.risetAll = function(){
		this._eatObject = new Array();
		this.sponRandomEatObject();
		this._spd = 8;

		this._time = 1800;
		this._point = 0;
		this._atuatu = 0;
		this._sponCount = 0;
		this._sponWait = 10;

		this._eatFlag = true;//食べることができる

		//効果音の配列
		this._se = new Array();

		this._isMobile = $gameSwitches.value(4);//モバイル判定のセット


	};

	//チュートリアル用に変数を変える
	Wolf_EatGame.prototype.risetAllTuto = function(){
		this._spd = 4;
		this._time = 180;
		this._sponCount = 0;
		this._sponWait = 10;
	};

	Wolf_EatGame.prototype.setEatObject = function(x,y,type,dire){
		var key = this.setTyingKey();
		this._eatObject.push(new EatObject(x,y,type,dire,key));
	};

	//セットされていないキーを探すまで繰り返す
	Wolf_EatGame.prototype.setTyingKey = function(){
		var tempKey = this.randomTyingKey();
		var count = 0;
		while(!this.isTyingKey(tempKey)){
			if(count >= 100) {console.log("break"); break;}
			tempKey = this.randomTyingKey();
		}
		return tempKey;

	};

	//ランダムでセットするキーを返す
	Wolf_EatGame.prototype.randomTyingKey = function(){
		var tempKey = Math.floor(Math.random() * 7);
		switch(tempKey){
			case 0:
				return 'ok';
				break;
			case 1:
				return 'escape';
				break;
			case 2:
				return 'left';
				break;
			case 3:
				return 'up';
				break;
			case 4:
				return 'right';
				break;
			case 5:
				return 'down';
				break;
			case 6:
				return 'shift';
				break;
		}
	};

	//入力されたキーがすでに設定済みか検索する
	Wolf_EatGame.prototype.isTyingKey = function(key){
		for(i = 0 ; i < this._eatObject.length ; i++){
			if(this._eatObject[i]._tyingKey === key) return false;
		}
		return true;
	};

	//引数tutorilがtrue ならチュートリアル用のセットを行う
	Wolf_EatGame.prototype.set = function(tutorial){
		WolfGame_Base.prototype.set.call(this);
		WolfGame_Base.prototype.playBgm.call(this,this._bgm);
		this.risetAll();
		if(tutorial) this.risetAllTuto();//チュートリアル用の変数設定
		this.draw();
	};


	Wolf_EatGame.prototype.main = function(){
		WolfGame_Base.prototype.main.call(this);
		this.update();
		this.draw();

	};

	Wolf_EatGame.prototype.end = function(){
		WolfGame_Base.prototype.end.call(this);
		this.risetValues();
	}


	//=============================-
	// ゲーム更新関係
	//=============================-

	Wolf_EatGame.prototype.update = function(){
		this.sponEatObject();
		this.updateEatObject();
		this.setValues();
		this.updateTime();
		this.updateAtuatu();
		this.checkEndGame();
		this.updateSe();
	};

	//=============================-
	// 食材オブジェクト関係
	//=============================-

	//食材オブェクトの更新
	Wolf_EatGame.prototype.updateEatObject = function(){
		for(i = 0 ; i < this._eatObject.length ; i++){

			if(this._eatObject[i]){
				if(this.checkOutScreenEatObject(i)) continue;//削除したら以下の処理を飛ばす
				this.moveEatObject(i);
				this.checkEatEatObject(i);
			}
		}

	};

	//オブジェクトを出現させる
	Wolf_EatGame.prototype.sponEatObject = function(){
		this._sponCount += 1;
		if(this.isSpon()) {
			this._sponCount = this.setSponCount();
			this.sponRandomEatObject();
			console.log("spon");
		}
		this.changeSponRate();//タイムオーバー近くで出現率を変化
		//if(TouchInput.isTriggered()) this.sponRandomEatObject();//デバック
	};

	Wolf_EatGame.prototype.sponRandomEatObject = function(){
		var dire = Math.sin(Math.random() * 360);
		dire = Math.round(dire);
		//方向によって初期xを変える
		if(dire < 0){
			var x = Graphics.width + objectMaxSize;
		}
		else{
			var x = objectMaxSize * -1 ;	
		}
		//yはランダムで
		var y = Math.random() * this._gameScreenHeight + this._gameTopUIHeight;
		y = Math.floor(y);
		var type = this.getRandomType();
		this.setEatObject(x,y,type,dire);
	}; 

	//それぞれの排出確率でタイプを設定
	Wolf_EatGame.prototype.getRandomType = function(){
		var rand = Math.floor(Math.random() * 100);
		var rate = 0;
		for(num = 0; num < this._objectSponRate.length ; num++){
			if(rand <= this._objectSponRate[num] + rate){
				return num;
			}
			rate += this._objectSponRate[num];
		}
		return 4;
	}

	//スポン間隔をランダムで設定
	Wolf_EatGame.prototype.setSponCount = function(){
		var rand = Math.floor(Math.random() * 3);
		switch(rand){
			case 0:
				return 0;
				break;
			case 1:
				return -10;
				break;
			case 2:
				return -30;
				break;
		}
		return 0;
	};

	Wolf_EatGame.prototype.changeSponRate = function(){
		if(this._time == 600) {this._objectSponRate = objectSponRateLast; this.setSe('lastSpart');console.log("change"); }
	}

	//出現の判定
	Wolf_EatGame.prototype.isSpon = function(){
		return this._sponCount > this._sponWait && this._eatObject.length < 7 && this._time > 0;
	};

	//画面外で削除
	Wolf_EatGame.prototype.checkOutScreenEatObject = function(id){
		if(this.isDeleteOutScreenEatObject(id)){
			console.log("delete");
			this.deleteEatObject(id);
			return true;
		}
		return false;
	};

	//画面外から出て、スポン位置を超えたらtrue
	Wolf_EatGame.prototype.isDeleteOutScreenEatObject = function(id){
		var object = this._eatObject[id];
		if(object._x > Graphics.width + object._width / 2 + objectMaxSize + 50) return true;
		if(object._x < 0 - object._width / 2 - objectMaxSize - 50) return true;
		if(object._y > Graphics.height + object._height / 2 + objectMaxSize + 50) return true;
		if(object._y < 0 - object._height / 2 - objectMaxSize - 50) return true;
	};

	//食材オブジェクｔの移動
	Wolf_EatGame.prototype.moveEatObject = function(id){
		this._eatObject[id]._x += this._spd * this._eatObject[id]._dire; 
	};


	//食材オブジェクトを食べたか判定
	Wolf_EatGame.prototype.checkEatEatObject = function(id){
		if(this.isTouchEatObject(id) || this.isKeyEatObject(id)) this.doEat(id);
	};

	Wolf_EatGame.prototype.isTouchEatObject = function(id){
		var object = this._eatObject[id];
		var correcHeight = 100;//y軸方向の当たり判定補正値
		var correcWidth = 100;//y軸方向の当たり判定補正値
		//タッチしていて、1クリックの時にtrue
		return $gameSystem.wolfIsCollisionQuadDot(object._x,object._y,object._width + correcWidth,object._height + correcHeight,TouchInput.x,TouchInput.y) && TouchInput.isTriggered();
	};

	//オブジェクトが画面内にあるかどうか判定(ｘ軸のみ)
	Wolf_EatGame.prototype.isInScreen = function(object){
		return (object._x - object._width / 2 <= 816 && object._x + object._width / 2 >= 0);
	}

	Wolf_EatGame.prototype.isKeyEatObject = function(id){
		var object = this._eatObject[id];
		return Input.isTriggered(object._tyingKey) && this.isInScreen(object);
	};

	//あつあつで食べられるか返す
	Wolf_EatGame.prototype.isAtuatuDoEat = function(object){
		if(this._eatFlag) return true;//あつあつしていなければ食べられる
		if(object._type == 3) return true;//あつあつしていても水なら食べられる
		return false;//食べられない
	}

	//食べた時の処理
	Wolf_EatGame.prototype.doEat = function(id){
		var object = this._eatObject[id];
		if(this.isAtuatuDoEat(object)){
			this.gainPoint(object._point);
			this.gainAtuatu(object._atuatu);
			this.deleteEatObject(id);
			if(object._type == 3){this.setSe('drink')}else{this.setSe('eat')};
			WolfGame_Base.prototype.criateMarkEffect.call(this,object._x,object._y,"GOOD");//攻撃できたらグッドエフェクトの作成
		}
	};



	Wolf_EatGame.prototype.gainPoint = function(amount){
		this._point += amount;
	};

	Wolf_EatGame.prototype.gainAtuatu = function(amount){
		this._atuatu += amount;
	};

	//指定IDのオブジェクトを削除
	Wolf_EatGame.prototype.deleteEatObject = function(id){
		this._eatObject.splice(id,1);
	};

	//=============================-
	// time関係
	//=============================-

	Wolf_EatGame.prototype.updateTime = function(){
		this.advanceTime(-1);
	};

	Wolf_EatGame.prototype.advanceTime = function(amount){
		this._time = Math.max(this._time + amount,0);;
	};

	//=============================-
	// アツアツゲージ関係
	//=============================-

	Wolf_EatGame.prototype.updateAtuatu = function(){
		this.setEatFlag();//あつあつ最高になったら食えないし、冷めれば戻る
		this.gainAtuatu(-1);//アツアツゲージの減少
		if(!this._eatFlag) this.gainAtuatu(-2);//あつあつしていたらさらに減少
	};


	Wolf_EatGame.prototype.gainAtuatu = function(amount){
		this._atuatu = Math.max(this._atuatu + amount,0);
		this._atuatu = Math.min(this._atuatu,this._maxAtuatu);
	};

	Wolf_EatGame.prototype.setEatFlag = function(){
		if(this._atuatu >= this._maxAtuatu) {this._eatFlag = false; this.changeBgm("Sitou");}
		if(!this._eatFlag && this._atuatu <= 0) {this._eatFlag = true; this.changeBgm(this._bgm);}
	};

	//=============================-
	// 変数をセットさせる
	//=============================-

	Wolf_EatGame.prototype.setValues = function(){
		this.setLimitTime();
		this.setScorePoint();
	};

	Wolf_EatGame.prototype.setLimitTime = function(){
		var temp = Math.floor(this._time / 60);
		$gameVariables.setValue(this._setTimeValue,temp);

	};

	Wolf_EatGame.prototype.setScorePoint = function(){
		$gameVariables.setValue(this._setPointValue,this._point);

	};
/*
	Wolf_EatGame.prototype.setAtuatuPoint = function(){
		$gameVariables.setValue(this._setAtuatuValue,this._atuatu);

	};
*/
	Wolf_EatGame.prototype.risetValues = function(){
		$gameVariables.setValue(this._setTimeValue,0);
		//$gameVariables.setValue(this._setPointValue,0);

	};

	//=============================-
	// ゲームを終了させる
	//=============================-

	Wolf_EatGame.prototype.isEndGame = function(){
		return this._time <= 0 && this._eatObject.length <= 0;//オブジェクトが流れ切ったら
	};

	Wolf_EatGame.prototype.checkEndGame = function(){
		if(this.isEndGame()){
			this.setSe('finish');
			WolfGame_Base.prototype.onEndSwitche.call(this);
		}
	};

	//=============================-
	// ゲーム描画関係
	//=============================-

	Wolf_EatGame.prototype.draw = function(){
		WolfGame_Base.prototype.draw.call(this);
		this.drawAtuatuBack(1);
		this.drawAtuatuGauge(2);
		this.drawEatObject(3);
		this.drawAtuatuEffect(50);
	};

	//オブジェクトの表示
	Wolf_EatGame.prototype.drawEatObject = function(id){
		var object = this._eatObject;
		for(i = 0 ; i < object.length ;i++){
			$gameScreen.showPicture(id + i * 2,object[i]._fileName,1,object[i]._x,object[i]._y,100.0,100.0,255,0);
			if(!this._isMobile) $gameScreen.showPicture(id + i * 2 + 1,object[i]._tyingKeyImgName,1,object[i]._x,object[i]._y,100.0,100.0,255,0);
		}
	};

	Wolf_EatGame.prototype.drawAtuatuBack = function(id){
		$gameScreen.showPicture(id,"Eat_AtuatuBack",0,0,0,100.0,100.0,255,0);

	};

	Wolf_EatGame.prototype.drawAtuatuGauge = function(id){
		var rate = this._atuatu / this._maxAtuatu * 100;
		$gameScreen.showPicture(id,"Eat_AtuatuGauge",0,0,0,rate,100.0,255,0);

	};

	Wolf_EatGame.prototype.drawAtuatuEffect = function(id){
		if(!this._eatFlag){
			$gameScreen.showPicture(id,"Eat_Effect",0,0,0,100.0,100.0,255,0);
		}
	};

	//=============================-
	// 効果音再生
	//=============================-

	Wolf_EatGame.prototype.setSe = function(code){
		this._se.push(code);
	}

	Wolf_EatGame.prototype.updateSe = function(){
		for(i = 0 ; i < this._se.length ; i++){
			this.playCodeSe(this._se[i]);
		}
		this.deleteSe();
	};

	Wolf_EatGame.prototype.playCodeSe = function(code){
		var seName = "";
		switch(code){
			case 'eat':
				seName = "Blow2";
				break;
			case 'drink':
				seName = "drink1";
				break;
			case 'finish':
				seName = "correct1";
				break;
			case 'lastSpart':
				seName = "Flash2";
				break;
		}

		WolfGame_Base.prototype.playSe(seName);
	};

	Wolf_EatGame.prototype.deleteSe = function(){
		this._se = [];
	}

	Wolf_EatGame.prototype.changeBgm = function(bgm){
		WolfGame_Base.prototype.playBgm.call(this,bgm);
	}

	//=============================-
	// ゲーム終了関係
	//=============================-
	
	//=========================================
	//オブジェクト生成
	//=========================================

	//=========================================
	// プラグインコマンドで制御
	//=========================================

	var _Game_Interpreter_pluginCommand = Game_Interpreter.prototype.pluginCommand;
	Game_Interpreter.prototype.pluginCommand = function(command,args)
	{
		_Game_Interpreter_pluginCommand.call(this,command,args);

		if(command === 'Wolf_EatGame'){

			switch (args[0])
			{
			case 'set':
				var tutorial = (args[1] === 'tutorial') ? true : false;
				this._Wolf_EatGame = new Wolf_EatGame();
				this._Wolf_EatGame.set(tutorial);
				break;			

			case 'main':
				this._Wolf_EatGame.main();
				break;
			case 'end':
				this._Wolf_EatGame.end();
				delete this._Wolf_EatGame;
				break;			

	
			}
		}

	};
		




})();
