﻿//----------------------------------------------------------------
// Varsion
// 0.9.0 2016_12_16 完成？　手直しあるかもしれないから取りあえず　0.9で
// 0.9.1 2016_12_16 タッチするまで待つように変更
// 2.0.0 2017_01_03 2バージョンに変更、カットイン、カットアウトで分ける 
// 2.0.1 2017_01_10 メニュー禁止フラグを降ろす命令を追加
//----------------------------------------------------------------
/*:ja
*@plugindesc カットイン
*@author うるふ
*
*@param Unknown Date
*@desc プロトタイプ
*default 不明
*
*@help
*
*カットイン演出用のプラグインです
*WolfEffect_CI set "表示画像名"
*
*
*/



(function() {

	//==================================
	//オブジェクト生成
	//==================================

	function WolfEffect_CI(){
		this.initialize.call(this);

	}


	//ゲームベースを継承
	WolfEffect_CI.prototype = Object.create(WolfGame_Base.prototype);
	WolfEffect_CI.prototype.constructor = WolfEffect_CI;


	//==================================
	//変数
	//==================================



	//==================================
	// プラグインパラメータ取得
	//==================================

	//パラメータ取得するときに使用
	var Parameters = PluginManager.parameters('Wolf_EffectCI');

	//=======================================
	// WolfEffect_CI メソッド
	//=======================================

	//=============================-
	// ゲーム基本メソッド
	//=============================-

	WolfEffect_CI.prototype.initialize = function(){
		WolfGame_Base.prototype.initialize.call(this);
		
		//this._act = true;

		this._pictureName = "";
		this._x = 0;
		this._y = 0;

		this._endPosition = 0;

		//this._positionMax = 0;
		//this._waitMax = 60;
		//this._waitCount = 0;

		this._seIn = "Flash2";
		this._seFlag = false;

	}

	WolfEffect_CI.prototype.risetAll = function(){
	//	this._waitCount = 0;
	//	this._act = true;
		this.risetPosition();
	}

	WolfEffect_CI.prototype.risetPosition = function(){
		this._x = - 816;
		this._y = 0;
		this._endPosition = 0;

		//this._positionMax = 0;
	}

	//ピクチャをセット
	WolfEffect_CI.prototype.setPictureName = function(fileName){
		this._pictureName = fileName;		
	}

	WolfEffect_CI.prototype.set = function(fileName){
		WolfGame_Base.prototype.set.call(this);

		this.setPictureName(fileName);
		this.risetAll();
		this.draw();
	};

	//カットアウトのセット
	WolfEffect_CI.prototype.setCutOut = function(fileName){
		WolfGame_Base.prototype.set.call(this);

		this.setPictureName(fileName);
		this.risetAll();
		this._x = 0;
		this._endPosition = 816;
		this._seIn = "";

		this.draw();
	};


	WolfEffect_CI.prototype.main = function(){
		WolfGame_Base.prototype.main.call(this);
		this.update();
		this.draw();

	};

	WolfEffect_CI.prototype.end = function(){
		//WolfGame_Base.prototype.end.call(this);
		this.erasePictures();
		this.permissionFast();
		this.downEndSwitche();
		$gameSwitches.setValue(this._banMenuSwitch,false);

	}


	//=============================-
	// ゲーム更新関係
	//=============================-

	WolfEffect_CI.prototype.update = function(){

	//	if(this._act == true || $gameSystem.wolfIsTriggeredOkorTouch() == true){

			this._act = true;

			this.playSE();

			//if(this.isMove())	this.updateMove();
			this.updateMove();

			//this.updateWait();

			//if(this.isStop()) this.setStop();

			if(this.isEnd()) WolfGame_Base.prototype.onEndSwitche.call(this);
		//}
	}

	WolfEffect_CI.prototype.updateMove = function(){
		this._x = Math.min(this._x + 30 , this._endPosition);
	}

/*
	//ウェイト時間の加算
	WolfEffect_CI.prototype.updateWait = function(){

		if(this._waitCount > 0){
			this._waitCount -= 1;
			if(this._waitCount == 0){
				this._act = false;//更新フラグを降ろす
			}
		}

	}
	*/

	WolfEffect_CI.prototype.playSE = function(){
		if(!this._seFlag){
			this._seFlag = true;
			WolfGame_Base.prototype.playSe.call(this,this._seIn);
		}
	}

/*
	WolfEffect_CI.prototype.setStop = function(){
		this._waitCount = this._waitMax;
		this._x = 0;
		this._positionMax = 916;
	}
*/
/*	//止める瞬間を取得
	WolfEffect_CI.prototype.isStop = function(){
		return (this._x >= this._positionMax) ? true : false;
	}
*/
/*
	//動作可能か判断
	WolfEffect_CI.prototype.isMove = function(){
		return (this._waitCount <= 0) ? true : false;
	}
*/
	WolfEffect_CI.prototype.isEnd = function(){
		//return (this._x >= 816) ? true : false;
		return (this._x >= this._endPosition) ? true : false;
	}
	//=============================-
	// ゲーム描画関係
	//=============================-

	WolfEffect_CI.prototype.draw = function(){
		WolfGame_Base.prototype.draw.call(this);
		this.drawPicture(1);
	}

	WolfEffect_CI.prototype.drawPicture = function(id){
		$gameScreen.showPicture(id,this._pictureName,0,this._x,this._y,100.0,100.0,255,0);

	}



	//=============================-
	// ゲーム終了関係
	//=============================-
	
	//=========================================
	//オブジェクト生成
	//=========================================
//	var _WolfEffect_CI = new WolfEffect_CI();


	//=========================================
	// プラグインコマンドで制御
	//=========================================

	var _Game_Interpreter_pluginCommand = Game_Interpreter.prototype.pluginCommand;
	Game_Interpreter.prototype.pluginCommand = function(command,args)
	{
		_Game_Interpreter_pluginCommand.call(this,command,args);

		if(command === 'Wolf_EffectCI'){

			switch (args[0])
			{
			case 'in':
				this._WolfEffect_CI = new WolfEffect_CI();
				this._WolfEffect_CI.set(String(args[1]));
				
				break;		
			case 'out':	
				this._WolfEffect_CI = new WolfEffect_CI();
				this._WolfEffect_CI.setCutOut(String(args[1]));
				break;
			case 'main':
				this._WolfEffect_CI.main();
				break;
			case 'end':
				this._WolfEffect_CI.end();
				delete this._WolfEffect_CI;
				break;			
	
			}
		}

	};
		




})();
