﻿//----------------------------------------------------------------
// Varsion
// 0.0.0 xxxx_xx_xx 内容
//----------------------------------------------------------------
/*:ja
*@plugindesc エンドロール
*@author うるふ
*
*@param Unknown Date
*@desc プロトタイプ
*default 不明
*
*@help
*
*
*
*演出用のプラグインです
*
*
*/



(function() {

	//==================================
	//ピクチャデータのクラス
	//==================================
	function EndRoleData(id,y,num){

		this._id = id;

		this._y = y;
		this._picName = "EndRole_" + num;

	}


	//==================================
	//オブジェクト生成
	//==================================

	function WolfEffect_ER(){
		this.initialize.call(this);

	}


	//ゲームベースを継承
	WolfEffect_ER.prototype = Object.create(WolfGame_Base.prototype);
	WolfEffect_ER.prototype.constructor = WolfEffect_ER;


	//==================================
	//変数
	//==================================



	//==================================
	// プラグインパラメータ取得
	//==================================

	//パラメータ取得するときに使用
	var Parameters = PluginManager.parameters('Wolf_EffectER');

	//=======================================
	// WolfEffect_ER メソッド
	//=======================================

	//=============================-
	// ゲーム基本メソッド
	//=============================-

	WolfEffect_ER.prototype.initialize = function(){
		WolfGame_Base.prototype.initialize.call(this);

		this._Data = new Array();

		this._showCount = 0;
		this._maxCount = 19;

		this._spd = 2;
	}

	WolfEffect_ER.prototype.risetAll = function(){
		this._showCount = 1;
		this._Data.push(new EndRoleData(2,724,this._showCount));
	}


	WolfEffect_ER.prototype.set = function(){
		WolfGame_Base.prototype.set.call(this);
		this.risetAll();
		this.draw();
	};


	WolfEffect_ER.prototype.main = function(){
		WolfGame_Base.prototype.main.call(this);
		this.update();
		this.draw();

	};

	WolfEffect_ER.prototype.end = function(){
		//WolfGame_Base.prototype.end.call(this);
		this.erasePictures();
		this.permissionFast();
		this.downEndSwitche();
		$gameSwitches.setValue(this._banMenuSwitch,false);
	}


	//=============================-
	// ゲーム更新関係
	//=============================-

	WolfEffect_ER.prototype.update = function(){
		this.updateData();

	}

	WolfEffect_ER.prototype.updateData = function(){

		for(var i = 0 ; i < this._Data.length ; i++){
			this._Data[i]._y -= this._spd;
		
			//中心で新しいデータを作成
			if(this.isCrieit(this._Data[i]._y) && this._showCount < this._maxCount){
				this.setData();
			}


			//画面害外に消えたら削除
			if(this._Data[i]._y <= -100 ){
				this._Data.shift();
				if(this.isEnd(this._Data.length)){
					WolfGame_Base.prototype.onEndSwitche.call(this);
				}
		
			}
		
		}
		
	}

	WolfEffect_ER.prototype.isCrieit  = function(y){
		return (y == 312) ? true : false;
	}



	WolfEffect_ER.prototype.isEnd = function(len){
		return (len == 0) ? true : false;
	}

	WolfEffect_ER.prototype.setData = function(){
		this._showCount += 1;
		this._Data.push(new EndRoleData( (this._showCount % 2 ) + 1 ,724,this._showCount));
	}

	//=============================-
	// ゲーム描画関係
	//=============================-

	WolfEffect_ER.prototype.draw = function(){
		WolfGame_Base.prototype.draw.call(this);
		this.drawPicture();
	}

	WolfEffect_ER.prototype.drawPicture = function(){

		for(var i  = 0 ; i < this._Data.length ; i++){
			$gameScreen.showPicture(this._Data[i]._id,this._Data[i]._picName,1,408,this._Data[i]._y,100.0,100.0,200,0);
		}
	}


	//=============================-
	// ゲーム終了関係
	//=============================-
	
	//=========================================
	//オブジェクト生成
	//=========================================
	var _WolfEffect_ER = new WolfEffect_ER();


	//=========================================
	// プラグインコマンドで制御
	//=========================================

	var _Game_Interpreter_pluginCommand = Game_Interpreter.prototype.pluginCommand;
	Game_Interpreter.prototype.pluginCommand = function(command,args)
	{
		_Game_Interpreter_pluginCommand.call(this,command,args);

		if(command === 'Wolf_EffectER'){

			switch (args[0])
			{
			case 'set':
				_WolfEffect_ER.set();
				console.log("set");
				
				break;			

			case 'main':
				_WolfEffect_ER.main();
				break;
			case 'end':
				_WolfEffect_ER.end();
				break;			
	
			}
		}

	};
		




})();
