﻿//----------------------------------------------------------------
// Varsion
// 0.0.0 xxxx_xx_xx 内容
//----------------------------------------------------------------
/*:ja
*@plugindesc ミニゲーム
*@author うるふ
*
*@param Unknown Date
*@desc プロトタイプ
*default 不明
*
*@help
*
*ミニゲーム
*
*演出用のプラグインです
*
*
*/



(function() {

	//==================================
	//オブジェクト生成
	//==================================

	function WolfEffect_ST(){
		this.initialize.call(this);


	}


	//ゲームベースを継承
	WolfEffect_ST.prototype = Object.create(WolfGame_Base.prototype);
	WolfEffect_ST.prototype.constructor = WolfEffect_ST;


	//==================================
	//変数
	//==================================



	//==================================
	// プラグインパラメータ取得
	//==================================

	//パラメータ取得するときに使用
	var Parameters = PluginManager.parameters('Wolf_MiniGame');

	//=======================================
	// WolfEffect_ST メソッド
	//=======================================

	//=============================-
	// ゲーム基本メソッド
	//=============================-

	WolfEffect_ST.prototype.initialize = function(){
		WolfGame_Base.prototype.initialize.call(this);

		this._pictureName = "";
		this._opt = 0;
		this._optAdd = 2;

		this._subValue = 24;

	}

	WolfEffect_ST.prototype.risetAll = function(){
	
	}

	//ピクチャをセット
	WolfEffect_ST.prototype.setPictureName = function(name){
		if(!name){
		var file = "SubTitle"
		var sub = $gameVariables.value(this._subValue);
		this._pictureName = file + sub;		
		}
		else{
			this._pictureName = name;		
		}
	}

	WolfEffect_ST.prototype.set = function(){
		WolfGame_Base.prototype.set.call(this);
		this.risetAll();
		this.draw();
	};


	WolfEffect_ST.prototype.main = function(){
		WolfGame_Base.prototype.main.call(this);
		this.update();
		this.draw();

	};

	WolfEffect_ST.prototype.end = function(){
		WolfGame_Base.prototype.end.call(this);
	}


	//=============================-
	// ゲーム更新関係
	//=============================-

	WolfEffect_ST.prototype.update = function(){
		this.updateOpt();
		if(this.isEnd()){
			WolfGame_Base.prototype.onEndSwitche.call(this);
		}
		
	}

	WolfEffect_ST.prototype.updateOpt = function(){
		this._opt += this._optAdd;
	}

	WolfEffect_ST.prototype.isEnd = function(){
		return (this._opt >= 300) ? true : false;
	}

	//=============================-
	// ゲーム描画関係
	//=============================-

	WolfEffect_ST.prototype.draw = function(){
		WolfGame_Base.prototype.draw.call(this);
		this.drawSubTitle(1);
	}


	WolfEffect_ST.prototype.drawSubTitle = function(id){
		$gameScreen.showPicture(id,this._pictureName,1,408,312,100.0,100.0,this._opt,0);
	}

	//=============================-
	// ゲーム終了関係
	//=============================-
	
	//=========================================
	//オブジェクト生成
	//=========================================
	var _WolfEffect_ST = new WolfEffect_ST();


	//=========================================
	// プラグインコマンドで制御
	//=========================================

	var _Game_Interpreter_pluginCommand = Game_Interpreter.prototype.pluginCommand;
	Game_Interpreter.prototype.pluginCommand = function(command,args)
	{
		_Game_Interpreter_pluginCommand.call(this,command,args);

		if(command === 'Wolf_EffectST'){

			switch (args[0])
			{
			case 'set':
				_WolfEffect_ST.set();
				_WolfEffect_ST.setPictureName(String(args[1]));
				console.log("set");
				
				break;			

			case 'main':
				_WolfEffect_ST.main();
				break;
			case 'end':
				_WolfEffect_ST.end();
				break;			
	
			}
		}

	};
		




})();
