﻿//----------------------------------------------------------------
// Varsion
// 0.2.0 2016_12_09 基盤の作成
//					ベジュ曲線でスコープを動かす
//		 			早送りの禁止
// 0.4.0 2016_12_10 ゲーム終了処理の作成
//					敵ＨＰゲージの作成
//					弾処理の作成
//					当たり判定の作成
//					弾発射でベジュ系統リセット
// 0.4.2 2016_12_13 WolfGame_Base を継承した形に変更
// 0.4.3 2016_12_13 WolfGame_Base 変更に伴い、ピクチャの最大、最小の変数を削除
//					グッド、バッドエフェクトの追加
// 0.4.6 2016_12_14 SEの追加
//					BGMの追加
//					window で取得していた変数がクロームでうまくできなかったので、408,312と直接代入に変更		
// 0.4.7 2016_12_17 四角形最小サイズ変更
// 0.5.0 2016_01_10 anCria 追加
//
//----------------------------------------------------------------
/*:ja
*@plugindesc 小便魔対決ゲーム
*@author うるふ
*
*@param Unknown Date
*@desc なし
*default 不明
*
*@help
*
*ミニゲーム
*小便魔対決ゲーミ
*
*
*/



(function() {

	//==================================
	//オブジェクト生成
	//==================================

	function WolfGame_Fav(){
		this.initialize.call(this);

	}


	//ゲームベースを継承
	WolfGame_Fav.prototype = Object.create(WolfGame_Base.prototype);
	WolfGame_Fav.prototype.constructor = WolfGame_Fav;


	//==================================
	//変数
	//==================================



	//==================================
	// プラグインパラメータ取得
	//==================================

	//パラメータ取得するときに使用
	var Parameters = PluginManager.parameters('Wolf_FavGame');

	//=======================================
	// WolfGame_Fav メソッド
	//=======================================

	//=============================-
	// ゲーム基本メソッド
	//=============================-

	WolfGame_Fav.prototype.initialize = function(){
		WolfGame_Base.prototype.initialize.call(this);
		//this._minPicId = 1;
		//this._maxPicId = 1;

		this._scopeP = [];//スコープ座標

		this._maxBullet = 5;//弾の最大数
		this._remaBullet = this._maxBullet;

		this._quadAdd = 50;//四角形加算値

		this._quadMin = 50;//四角形最小値

		this._minTime = 5;//スコープ速度
		this._time = this._miniTime;

		//ベジュ曲線必要座標
		this._sp = new Array(2);
		this._dp = new Array(2);
		this._ep = new Array(2);

		//活動範囲の四角形の座標
		this._quadX = [136,136,670,670];
		this._quadY = [574, 50,574, 50];

		//四角形初期座標
		this._quadX_Origin = [136,136,670,670];
		this._quadY_Origin = [574, 50,574, 50];

		this._index = 0;//現在の四角形点座標位置
		this._patern = 0;//スコープ移動方向
		this._count = 0;//時間のカウント

		//敵
		this._maxHp = 3;
		this._remaHp = this._maxHp;

		this._gaugeRate = 100.0;

		//se file name
		this._seGood = "Item3";
		this._seMiss = "Disappointment";
		this._seFav = "fav";
		//bgm file name
		this._bgm = "Cooking_War";

	}

	WolfGame_Fav.prototype.risetAll = function(){
		this.risetBezier();
		this.risetPlayer();
		this.risetEnemy();
	}

	WolfGame_Fav.prototype.risetBezier = function(){
		this.risetQuad();
		this.risetBeziValues();
		this.risetBeziPoint();
	}

	WolfGame_Fav.prototype.risetBeziValues = function(){
		this._time = this._minTime;
		this._index = 0;
		this._patern = 0;
		this._count = 0;
	}

	WolfGame_Fav.prototype.risetQuad = function(){
		this._quadX = $gameSystem.wolfCopyArray(this._quadX_Origin);
		this._quadY = $gameSystem.wolfCopyArray(this._quadY_Origin);
	}

	WolfGame_Fav.prototype.risetBeziPoint = function(){
		this._scopeP[0] = this._quadX[0];
		this._scopeP[1] = this._quadY[0];

		this._sp[0] = this._quadX[0];
		this._sp[1] = this._quadY[0];

		this._dp[0] = this._quadX[0] - 50;
		this._dp[1] = 312;

		this._ep[0] = this._quadX[1];
		this._ep[1] = this._quadY[1];

	}

	WolfGame_Fav.prototype.risetEnemy = function(){
		this._remaHp = this._maxHp;
	}

	WolfGame_Fav.prototype.risetPlayer = function(){
		this._remaBullet = this._maxBullet;

	}

	WolfGame_Fav.prototype.set = function(){
		WolfGame_Base.prototype.set.call(this);
				console.log("set");

		WolfGame_Base.prototype.playBgm.call(this,this._bgm);
		this.risetAll();
		this.draw();
	};


	WolfGame_Fav.prototype.main = function(){
		WolfGame_Base.prototype.main.call(this);
		this.update();
		this.draw();

	};

	WolfGame_Fav.prototype.end = function(){
		WolfGame_Base.prototype.end.call(this);
	}


	//=============================-
	// ゲーム更新関係
	//=============================-

	WolfGame_Fav.prototype.update = function(){
		this.actionBullet();
		this.updateScope();
		this.updateTime();
		this.endGame();

	}

	WolfGame_Fav.prototype.updateScope = function(){
		var t = this._count / this._time;

		//スコープ座標をベジュで計算
		for(var i = 0 ; i < 2 ; i++){
			this._scopeP[i] = $gameSystem.wolfBezier(this._sp[i],this._dp[i],this._ep[i],t);
		}

		//移動しきったら次の目的座標へ
		if(t >= 1){
			this.change();
		}
		
	}

	WolfGame_Fav.prototype.change = function(){
		//カウントを進める
		this.forward();

		//一周したら四角形を小さくする
		if(this._patern == 0){
			this.scaleDownQuad();
		}
		//速度の計算
		this.changeTime();
		//ベジュの座標計算
		this.changeBezierPoint();
	}

	WolfGame_Fav.prototype.forward = function(){
		this._count = 0;
		this._index = (this._index + 1 )  % 4;
		this._patern = (this._patern + 1) % 4;
	}
	WolfGame_Fav.prototype.scaleDownQuad = function(){
		//四角形が最小単位をこえないまで小さくする
		if(this._quadX[0] < 312 - this._quadMin / 2){

			var rateX = 1;
			var rateY = -1;

			for(var i = 0 ; i < 4 ; i++){
				//ｘ座標、　+ + - - で加算されていくので
				if(i >= 2){
					rateX = -1;
				}
				this._quadX[i] += this._quadAdd * rateX;
				this._quadY[i] += this._quadAdd * rateY;

				//ｙ座標、 - + - + で加算されていくので
				rateY *= -1;
			}

		}
	}

	WolfGame_Fav.prototype.changeBezierPoint = function(){

		var endIndex = (this._index + 1 ) % 4;

		//方向によってベジュ曲線の方向値を変える
		if(this._patern % 2 == 0){
			//ｘ座標の位置によって加算か減算か決める
			if (this._quadX[endIndex] < 408) {
				this._dp[0] = this._quadX[endIndex] - 50;
			}else{
				this._dp[0] = this._quadX[endIndex] + 50;

			}
		}else{
			//ナナメ方向は中心地を通る
			this._dp[0] = 408;
		}

		//ｙはつねに中心地
		this._dp[1] = 312;

		//スタート地は前回の最終地
		this._sp[0] = this._ep[0]; 
		this._sp[1] = this._ep[1]; 

		//四角形の次の座標を最終地に
		this._ep[0] = this._quadX[endIndex];
		this._ep[1] = this._quadY[endIndex];
	}

	WolfGame_Fav.prototype.changeTime = function(){
		//方向によって速度を変える
		if(this._patern % 2 == 0){
			this._time = this._minTime;
		}
		else{
			this._time = this._minTime * 1.5;
		}
	}

	WolfGame_Fav.prototype.updateTime = function(){
		this._count += 1;
	}

	WolfGame_Fav.prototype.actionBullet = function(){
		if($gameSystem.wolfIsTriggeredOkorTouch()){

			WolfGame_Base.prototype.playSe(this._seFav);//SEの再生

			var x = this._scopeP[0];
			var y = this._scopeP[1];

/*
			//タッチ座標がなかったら中心に表示
			if(x == 0){
				x = 408;
				y = 312;
			}
*/
			if(this.checkCollision()){
				WolfGame_Base.prototype.playSe(this._seGood);//SEの再生
				WolfGame_Base.prototype.criateMarkEffect.call(this,x,y,"GOOD");//攻撃できたらグッドエフェクトの作成	
			}else{
				WolfGame_Base.prototype.playSe(this._seMiss);//SEの再生
				WolfGame_Base.prototype.criateMarkEffect.call(this,x,y,"BAD");//攻撃できたらバッドエフェクトの作成
			}

			this.dellBullet(1);
			this.risetBezier();
		}
	}

	


	WolfGame_Fav.prototype.dellBullet = function(dell){
		this._remaBullet -= dell;
	}
	
	WolfGame_Fav.prototype.checkCollision = function(){
		if($gameSystem.wolfIsCollisionCircle(this._scopeP[0],this._scopeP[1],100,100,408,312,200,300)){
			this.damageEnemy(1);
			return true;
		}else{
			return false;
		}
	}

	WolfGame_Fav.prototype.damageEnemy = function(damage){
		this._remaHp -= damage;
	}

	WolfGame_Fav.prototype.isEndGame = function(){
		var end = false;
		if(this._gaugeRate <= 0){
			end = true;
		}
		if(this._remaHp > 0 && this._remaBullet <= 0){
			//非ゲームクリアのフラグを上げる
			WolfGame_Base.prototype.onAnCriaSwitche.call(this);
			end = true
		}
		return end;
	}

	WolfGame_Fav.prototype.endGame = function(){
		if(this.isEndGame()){
			WolfGame_Base.prototype.onEndSwitche.call(this);
		}
	}



	//=============================-
	// ゲーム描画関係
	//=============================-

	WolfGame_Fav.prototype.draw = function(){
		WolfGame_Base.prototype.draw.call(this);

		this.drawBackGround(1);
		this.drawTarget(2);
		this.drawGauge(3);//3 + 2
		this.drawScope(6);
		this.drawBullet(7);
		//WolfGame_Base.prototype.drawGoodMark.apply(this,6,0,0);
		//WolfGame_Base.prototype.drawMarkEffect.call(this);
	}

	WolfGame_Fav.prototype.drawBackGround = function(id){
		$gameScreen.showPicture(id,"Fav_BackGround",0,0,0,100.0,100.0,255,0);

	}

	WolfGame_Fav.prototype.drawTarget = function(id){
		$gameScreen.showPicture(id,"Fav_Target",1,408,312,100.0,100.0,255,0);

	}

	WolfGame_Fav.prototype.drawGauge = function(id){
		this._gaugeRate = Math.max(this._remaHp / this._maxHp * 100 , this._gaugeRate - 1);

		$gameScreen.showPicture(id,"Fav_SmellGaugeFrameBack",0,50,90,100.0,100.0,255,0);	
		$gameScreen.showPicture(id + 1,"Fav_SmellGauge",0,50,90,this._gaugeRate,100.0,255,0);	
		$gameScreen.showPicture(id + 2,"Fav_SmellGaugeFrame",0,50,90 - 60 - 30,100.0,100.0,255,0);	
	}

	WolfGame_Fav.prototype.drawScope = function(id){
		$gameScreen.showPicture(id,"Fav_Scope",1,this._scopeP[0],this._scopeP[1],100.0,100.0,255,0);

	}

	WolfGame_Fav.prototype.drawBullet = function(id){

		for(var i = 0 ; i < this._remaBullet ; i++){
		$gameScreen.showPicture(id + i,"Fav_Bullet",0,15 + (i * (50 + 10)),624 - 15 - 50,100.0,100.0,255,0);
		}
	}


	//=============================-
	// ゲーム終了関係
	//=============================-
	
	//=========================================
	//オブジェクト生成
	//=========================================
	//var _WolfGame_Fav = new WolfGame_Fav();


	//=========================================
	// プラグインコマンドで制御
	//=========================================

	var _Game_Interpreter_pluginCommand = Game_Interpreter.prototype.pluginCommand;
	Game_Interpreter.prototype.pluginCommand = function(command,args)
	{
		_Game_Interpreter_pluginCommand.call(this,command,args);

		if(command === 'Wolf_FavGame'){

			switch (args[0])
			{
			case 'set':
				this._WolfGame_Fav = new WolfGame_Fav();
				this._WolfGame_Fav.set();
				console.log(this);
				break;			

			case 'main':
				this._WolfGame_Fav.main();
				break;
			case 'end':
				this._WolfGame_Fav.end();
				delete this._WolfGame_Fav;
				break;			
	
			}
		}

	};
		




})();
