﻿//----------------------------------------------------------------
// Varsion
// 0.2.0 2016_12_10 基本形の作成
//					早送り禁止実装
//					使用ピクチャすべて削除実装
// 0.2.3 2015_12_13 エフェクトマークの表示を追加
//					そういば、すべてのピクチャを削除できるメソッドがもともとあったのでそれを実装、ピクチャＩＤの最大変数の削除
// 0.2.4 2015_12_14 SEをならすメソッドの追加
//					BGMをならすメソッドの追加
// 0.3.0 2017_01_10 メニュー禁止フラグ、クリア判定フラグの追加
//----------------------------------------------------------------

/*:ja
*@plugindesc ミニゲームベースオブジェクト
*@author うるふ
*
*@param End_Switch
*@desc ゲーム終了フラグのスイッチ番号
*@default 20
*
*@param anCria_Switch
*@desc クリア判定のスイッチ、onで非クリア
*@default 17
*
*@param BanMenu_Switch
*@desc メニュー呼び出し禁止フラグ
*@default 18
*
*
*@help
*
*
*
*/



	//即時関数の外で定義
	function WolfGame_Base(){
		this.initialize.call(this);
	}

(function() {


	//==================================
	// プラグインパラメータ取得
	//==================================

	var Parameters = PluginManager.parameters('Wolf_GameBase');


	//後からメソッド追加する
	WolfGame_Base.prototype.initialize = function(){
		//this._minPicId = 0;
		//this._maxPicId = 0;

		 this._endSwitch = Number(Parameters["End_Switch"]);
		 this._anCriaSwitch = Number(Parameters["anCria_Switch"]);
		 this._banMenuSwitch = Number(Parameters["BanMenu_Switch"]);

		 this._dataMarkEffect= [];//エフェクトデータ
		 this._fileNameGood = "Effect_GoodBowel"//ベンジョミン用、グッドマーク
		 this._fileNameVeryGood = "Effect_VeryGoodBowel"//ベンジョミン用、ベリーグッドマーク
		 this._fileNameBad = "Effect_Diarrhoea"//ベンジョミン用、バッドマーク
	}

	WolfGame_Base.prototype.set = function(){
		this.disableFast();
		this.downEndSwitche();
		this.downAnCriaSwitche();
		this._dataMarkEffect= [];//エフェクトデータ
		$gameSwitches.setValue(this._banMenuSwitch,true);

	}

	WolfGame_Base.prototype.main = function(){

	}

	WolfGame_Base.prototype.draw = function(){
		this.erasePictures(); //ピクチャの消去
		this.drawMarkEffect();//エフェクトの表示
	}

	WolfGame_Base.prototype.end = function(){
		this.erasePictures();
		this.permissionFast();
		this.downEndSwitche();
		this.stopBgm();
		$gameSwitches.setValue(this._banMenuSwitch,false);

	}


	//早送り禁止、トリアコンタンさまのプラグイン使用
	WolfGame_Base.prototype.disableFast = function(){
		$gameSystem.disableFastForward = true;

	}
	//早送り許可
	WolfGame_Base.prototype.permissionFast = function(){
		$gameSystem.disableFastForward = false;

	}

	WolfGame_Base.prototype.erasePictures　= function(){
		//$gameSystem.wolfPictureErase(this._minPicId,this._maxPicId);
		$gameScreen.clearPictures();//そういえばすべてのピクチャを削除するメソッドありました( > ω　<)/
	}

	//フラグをあげ、ゲームを終わらせる
	WolfGame_Base.prototype.onEndSwitche = function(){
		$gameSwitches.setValue(this._endSwitch,true);

	}

	WolfGame_Base.prototype.downEndSwitche = function(){
		$gameSwitches.setValue(this._endSwitch,false);

	}


	//ゲームがクリアしていなければスイッチをオンにする
	WolfGame_Base.prototype.onAnCriaSwitche = function(){
		$gameSwitches.setValue(this._anCriaSwitch,true);

	}

	//ゲームがクリアしていなければスイッチをオンにする
	WolfGame_Base.prototype.downAnCriaSwitche = function(){
		$gameSwitches.setValue(this._anCriaSwitch,false);

	}



	//マークエフェクトの表示
	WolfGame_Base.prototype.drawMarkEffect = function(){

		for(var i = 0 ; i < this._dataMarkEffect.length ; i++){
			$gameScreen.showPicture(50 + i,this._dataMarkEffect[i][3],1,this._dataMarkEffect[i][0],this._dataMarkEffect[i][1],100.0,100.0,this._dataMarkEffect[i][2],0);
			if(this._dataMarkEffect[i][2] > 0){

				if(this._dataMarkEffect[i][2] < 255) {
					this._dataMarkEffect[i][1] -= 4; //一定期間表示し、上に消えていく
				}

				this._dataMarkEffect[i][2] -= 4;

			}else{
				this._dataMarkEffect.shift();
			}

		}
	};

	//エフェクトマークのデータを作成する
	WolfGame_Base.prototype.criateMarkEffect = function(x,y,effectName){
		var str = "";
		if(effectName == "GOOD"){
			str = this._fileNameGood;
		}
		else if(effectName == "BAD"){
			str = this._fileNameBad;
		}else if(effectName == "VERYGOOD"){
			str = this._fileNameVeryGood;
		}else{
			console.log("エフェクトネームエラー　： ファイル引数 = " + effectName);
		}
		this._dataMarkEffect.push([x,y,300,str]);
		//console.log("namw = " + this._dataMarkEffect[0]);
	}

	//SEをファイル名だけで鳴らす
	WolfGame_Base.prototype.playSe = function(name){
		AudioManager.playSe({"name":name,"volume":100,"pitch":100,"pan":0});
	}

	//BGMをファイル名だけで鳴らす
	WolfGame_Base.prototype.playBgm = function(name){
		AudioManager.playBgm({"name":name,"volume":100,"pitch":100,"pan":0});
	}

	WolfGame_Base.prototype.stopBgm = function(){
		AudioManager.playBgm({"name":"","volume":100,"pitch":100,"pan":0});
	}


})();
