﻿//----------------------------------------------------------------
// Varsion
// 1.0.0 コピー
// 1.1.0 drawPicture追加
// 1.2.3 2016_12_09 wolfBezier 追加
//					wolfIsTriggeredOkorTouch 追加
//					wolfIsPressedOkorTouch 追加
//					OneTouch をコメントアウト
// 1.2.6 2016_12_10 wolfIsCollison - Quad - and - Circle - 追加
//					wolfCopyArray 追加
// 1.2.7 2016_12_10 wolfIsCollisonDot 追加
// 1.3.0 2016_12_11 wolfReturnCursorKey 追加
//					Drag取得系　追加
//					ピクチャの回転を行うメソッドGame_Picture に追加定義
// 1.3.1 2016_12_13 wolfReturnCursorKey を 
//					wolfReturnIsPressedCursorKey , wolfReturnIsTriggeredCursorKey に分割
// 1.3.3 2017_01_13 wolfSelfSwitchesOn,wolfSelfSwitchesOff を追加
// 1.3.4 2017_01_31 wolfLengthText を追加
//
//----------------------------------------------------------------

/*:ja
*@plugindesc うるふ作成ライブラリ
*@author うるふ
*
*@param Unknown Date
*@desc ライブラリ
*default 不明
*
*@help
*
*ピクチャ削除
*$gameSystem.wolfPictureErase(min,max);
*
* ベジュ曲線の値を取得 time = (0 ~ 1)
* wolfBezier(startP,direP,endP,time) 
*
*
*/




(function() {


 	/*
  	//========================
	//Scene_Bootの再定義によってあらかじめ画像をロードしておく
	//=========================
	Scene_Boot.prototype.create = function(){
		
		Scene_Base.prototype.create.call(this);
		
		//loadDatabaseメソッド
		DataManager.loadDatabase();
		
		//
		ConfigManager.load();
		
		
		this.loadSystemImages();
		
		this.loadTouch_Effect();
	};
	
	
	//タッチエフェクトのオリジナルロード（開始直後にロードしておく）
	Scene_Boot.prototype.loadTouch_Effect = function(){
		var name = 'HitIce_0';
		for(var i = 1 ; i <= 5; i++){
			var p_name = name + i
			ImageManager.loadPicture(p_name);
		}
	}
  	*/
  

	var _Game_Interpreter_pluginCommand = Game_Interpreter.prototype.pluginCommand;

	Game_Interpreter.prototype.pluginCommand = function(command,args)
	{
		_Game_Interpreter_pluginCommand.call(this,command,args);

		if(command === 'Wolf_Library'){

			
			switch (args[0]){

			case 'sort':
				$gameSystem.wolfSort();
				break;		
			}
			
		}

	};
		
	//画像の角度変更メソッド、$gameScreen.picture(id).changeAngle　で実行させる
	Game_Picture.prototype.changeAngle = function(ang){
		this._angle = ang;
	}	

	//ピクチャ削除のメソッド(min ～ max)
	Game_System.prototype.wolfPictureErase = function(min,max)
	{
		for(var i = min ; i <= max ; i++)
		{
 
			$gameScreen.erasePicture(i);
		}	
				
	};

	
	//変数初期化のメソッド(min ～ max)
	Game_System.prototype.wolfVariablesRiset = function(min,max)
	{
		for(var i = min ; i <= max ; i++)
		{
 
			$gameVariables.setValue(i,0);;
		}	
				
	};

	//スイッチ初期化のメソッド(min ～ max)
	Game_System.prototype.wolfSwitchesRiset = function(min,max)
	{
		for(var i = min ; i <= max ; i++)
		{
 
			$gameSwitches.setValue(i,false);;
		}	
				
	};

	//配列のソート
	function QSort(x,left,right)
	{
		var i = left;
		var j = right;

		var pivot = x[parseInt((left + right) / 2)];

		while(1)
		{
			while(x[i] < pivot)
			{
				i += 1;
			}

			while(x[j] > pivot)
			{
				j -= 1;
			}

			if(i >= j)
			{
				break;
			}

			Swap(x,i,j);
			i += 1;
			j -= 1;
		}
		if(left < i - 1)
		{
			QSort(x,left,i - 1);
		}
		if(right > j + 1)
		{
			QSort(x,j + 1,right);
		}

	}

	function Swap(x,i,j)
	{
		var temp;
		
		temp = x[i];
		x[i] = x[j];
		x[j] = temp;
	}

	//配列のソート
	Game_System.prototype.wolfQSort = function(x)
	{
		//ソート
		QSort(x,0,x.length-1);
	};

	//配列のコピー
	Game_System.prototype.wolfCopyArray = function(arr){
		var newarr = [];
		for(var i = 0 ; i < arr.length;i++){
			if(Array.isArray(arr[i])){
				newarr[i] = wolfCopyArray(arr[i]);
			}else{
				newarr[i] = arr[i];
			}
		}
		return newarr;
	}


	/*
	//タッチしている時間を取得
	var touch_count = 0;

	//１タッチにだけ、trueを返す
	Game_System.prototype.wolfOneTouch = function()
	{
		if(TouchInput.isPressed())
		{
			touch_count += 1;
		}
		else
		{
			touch_count = 0;
		}

		if(touch_count == 1)
		{
			return true;
		}
		else
		{
			return false;
		}	
	};
	*/

	
	//タッチ中のカウントを返す
	Game_System.prototype.wolfTouchCount = function()
	{
	
		
		if(TouchInput.isPressed())
		{
			touch_count += 1;
			return touch_count;
		}
		else
		{
			touch_count = 0;		
			return 0;
		}

	};
	
	//イージング計算(現在地、目的地、イーシング値）
	//イージングの加算値を返す
	Game_System.prototype.wolfMathEasing = function(value,target,easing)
	{
		return (target - value) * easing;
	};
	
	
	
	//画像の描画
	//imgフォルダ内にあるフォルダの名前の指定、
	//画像名の指定(拡張子抜き)、読み込む画像の開始X座標、
	//読み込む画像の開始Y座標、描写位置X座標、描写位置Y座標、幅、高さ
	Window_Base.prototype.drawPicture = function(dir,filename,sx,sy,x,y,w,h,hue){
		
		var bitmap = ImageManager.loadBitmap('img/' + dir + '/',filename,hue,true);
		
		this.contents.blt(bitmap,sx,sy,w,h,x,y);
	};

	//ベジュ曲線 座標
	//スタート位置、方向位置、最終位置、時間（0~1)を引数に持つ
	//現在の座標を返す	
	Game_System.prototype.wolfBezier = function(startP,direP,endP,time){

		var t2 = 1 - time;

		var p1 = t2 * t2 * startP;
		var p2 = 2 * t2 * time * direP;
		var p3 = time * time * endP;

		return p1 + p2 + p3;

	}

	//決定キーまたはタッチの時に一度だけtrueを返す
	Game_System.prototype.wolfIsTriggeredOkorTouch = function(){
		if(Input.isTriggered('ok') || TouchInput.isTriggered() ){
			return true;
		}
		else{
			return false;
		}
	}

	//決定キーまたはタッチが押されている間
	Game_System.prototype.wolfIsPressedOkorTouch = function(){
		if(Input.isPressed('ok') || TouchInput.isPressed() ){
			return true;
		}
		else{
			return false;
		}
	}


	//押されている方向キーを返す
	Game_System.prototype.wolfReturnIsPressedCursorKey = function(){
		var check = "";

		if(Input.isPressed('left')){
			check = "LEFT";
		}
		if(Input.isPressed('right')){
			check = "RIGHT";
		}

		if(Input.isPressed('up')){
			check = "UP";
		}

		if(Input.isPressed('down')){
			check = "DOWN";
		}

		return check;
	}

	//押されている方向キーを返す
	Game_System.prototype.wolfReturnIsTriggeredCursorKey = function(){
		var check = "";

		if(Input.isTriggered('left')){
			check = "LEFT";
		}
		if(Input.isTriggered('right')){
			check = "RIGHT";
		}

		if(Input.isTriggered('up')){
			check = "UP";
		}

		if(Input.isTriggered('down')){
			check = "DOWN";
		}

		return check;
	}

	//四角形の当たり判定
	Game_System.prototype.wolfIsCollisionQuad = function(x1,y1,sizeX1,sizeY1,x2,y2,sizeX2,sizeY2){

		var check = 0;
		var checkX = (sizeX1 + sizeX2) / 2;
		var checkY = (sizeY1 + sizeY2) / 2;

		if(Math.abs(x1 - x2) <= checkX){
			check += 1;
		}

		if(Math.abs(y1 - y2) <= checkY){
			check += 1;
		}

		if(check == 2){
			return true;
		}
		else{
			return false;
		}


	}

	//円の当たり判定
	Game_System.prototype.wolfIsCollisionCircle = function(x1,y1,sizeX1,sizeY1,x2,y2,sizeX2,sizeY2){

		//サイズで小さい方を直径に採用
		var diameter1 = Math.min(sizeX1,sizeY1);
		var diameter2 = Math.min(sizeX2,sizeY2);

		var checkRadius = (diameter1 + diameter2) /  2;

		//三角関数計算
		var c = (x1 - x2 ) * (x1 - x2) + (y1 - y2) * (y1 - y2);

		if( c <= checkRadius * checkRadius){
			return true;
		}
		else{
			return false;
		}

	}

	//円と点の当たり判定
	Game_System.prototype.wolfIsCollisionCircleDot = function(x1,y1,sizeX1,sizeY1,x2,y2){

		//サイズで小さい方を直径に採用
		var diameter1 = Math.min(sizeX1,sizeY1);

		var checkRadius = diameter1 / 2;

		//三角関数計算
		var c = (x1 - x2 ) * (x1 - x2) + (y1 - y2) * (y1 - y2);

		if( c <= checkRadius * checkRadius){
			return true;
		}
		else{
			return false;
		}

	}

	//四角形と点の当たり判定
	Game_System.prototype.wolfIsCollisionQuadDot = function(x1,y1,sizeX1,sizeY1,x2,y2){

		var check = 0;
		var checkX = sizeX1 / 2;
		var checkY = sizeY1 / 2;

		if(Math.abs(x1 - x2) <= checkX){
			check += 1;
		}

		if(Math.abs(y1 - y2) <= checkY){
			check += 1;
		}

		if(check == 2){
			return true;
		}
		else{
			return false;
		}


	}

	var positionDrag = [-100,-100];//ドラッグ座標保持
	var positionDragEnd = [-100,-100];//ドラッグ終了地点座標
	var crickFlag = false;

	//ドラッグ取得のための更新
	Game_System.prototype.wolfReturnDragDier = function(){

		check = "";

		//最初のクリック座標を保持
		if(TouchInput.isTriggered()){
			positionDrag[0] = TouchInput.x;
			positionDrag[1] = TouchInput.y;
		}

		//クリック中はフラグを上げ続ける
		if(TouchInput.isPressed()){
			crickFlag = true;
		}
		//クリックしていない時、フラグが上がっていたら（つまり、離したとき）に実行
		else if(crickFlag == true){
			crickFlag = false;

			positionDragEnd[0] = TouchInput.x;
			positionDragEnd[1] = TouchInput.y;

			check = this.wolfMathDragDier(positionDrag[0],positionDrag[1],positionDragEnd[0],positionDragEnd[1]);//方向を計算
		}

		return check;
		
	};
	
	//ドラッグ方向を計算
	Game_System.prototype.wolfMathDragDier = function(x1,y1,x2,y2){
		
		var check = "";

		var x = x1 - x2;
		var y = y1 - y2;

		
		//変化量が大きい方を選ぶ
		if(Math.abs(x) >= Math.abs(y)){
			if(x == 0){
				check = "";
			}
			else if(x > 0){
				check = "LEFT";
			}else{
				check = "RIGHT";

			}
		}else{

			if(y > 0){
				check = "UP";
			}
			else{
				check = "DOWN";
			}
		}

		if(crickFlag == true){

		}

		return check;
	};

	//同一マップ内のセリフスイッチを一括でオンにする
	Game_System.prototype.wolfSelfSwitchesOn = function(map,swit,min,max){
		for(var i = min ; i <= max ; i++){
			var key = [map,i,swit];
			$gameSelfSwitches.setValue(key,true);
		}
	}

	//同一マップ内のセリフスイッチを一括でオフにする
	Game_System.prototype.wolfSelfSwitchesOff = function(map,swit,min,max){
		for(var i = min ; i <= max ; i++){
			var key = [map,i,swit];
			$gameSelfSwitches.setValue(key,false);
		}
	}

	//日本語を2,英語を1で文字列を計算
	Game_System.prototype.wolfLengthText = function(str){
		var len = 0;
		str = escape(str);
		for(i =  0 ; i < str.length ; i++){

			if(str.charAt(i) == "%"){
				if(str.charAt(++i) == "u"){
					i += 4;
					len++;
				}
			}

			len++;
		}
		return len;
	}

})();
