/*:ja
*@plugindesc オリジナルメニュー
*
*@param Unknown Date
*@desc オリジナルメニュー
*default 不明
*
*@help
*
*プロトタイプ
*
*
*
*/
// =====================================
// Varsion
// 0.5.0 2017/01/02 メニューを力技で上書きしました。（やばさ感）
// 0.6.0 2017/01/03 バックグラウドの表示を Yoji Ojimaさまの　AltMenuScreen2.js からいただきました。
// 0.7.0 2017_01_04　セーブの制限機能、正直、うまくいくかドキドキです
// 0.7.1 2017_01_04 ランダムでバックを変える
// 0.7.5 2017_01_09 ｃキーを入力で追加する
// =====================================



(function() {

	//========================
	//Game_Interpreterの再定義
	//=========================

	//現在のイベント実行がメッセージの時だけセーブ可能に
	var _Game_Interpreter_setWaitMode = Game_Interpreter.prototype.setWaitMode;
	Game_Interpreter.prototype.setWaitMode = function() {
		_Game_Interpreter_setWaitMode.apply(this,arguments);
		//メッセージの時だけ、メニュー呼び出しを許可
		var flag = (arguments[0] === "message") ? true : false; 
		//上書き、強制禁止があれば上書きで禁止する
		if($gameSwitches.value(18)){
			flag = false;
		}
		$gameSwitches.setValue(19,flag);
	};

	//========================
	//Inputの再定義,キーの追加
	//=========================
	Input.keyMapper = {
   	9: 'tab',       // tab
    13: 'ok',       // enter
    16: 'shift',    // shift
    17: 'control',  // control
    18: 'control',  // alt
    27: 'escape',   // escape
    32: 'ok',       // space
    33: 'pageup',   // pageup
    34: 'pagedown', // pagedown
    37: 'left',     // left arrow
    38: 'up',       // up arrow
    39: 'right',    // right arrow
    40: 'down',     // down arrow
    45: 'escape',   // insert
    81: 'pageup',   // Q
    87: 'pagedown', // W
    88: 'escape',   // X
    90: 'ok',       // Z
    96: 'escape',   // numpad 0
    98: 'down',     // numpad 2
    100: 'left',    // numpad 4
    102: 'right',   // numpad 6
    104: 'up',      // numpad 8
    120: 'debug',    // F9
    //追加
    67: 'Key_C'
	};
	//バックグラウンドの画像
	var backGroundBitmap = ["WC_Benjomin",
							"WC_Shit",
							"WC_Seimei",
							"WC_Bahunmal"];
	var StoryValue = 25;//ストーリー変数番号

	//========================
	//Scene_Bootの再定義
	//=========================
	Scene_Boot.prototype.create = function(){
		
		Scene_Base.prototype.create.call(this);
		
		//loadDatabaseメソッド
		DataManager.loadDatabase();
		
		//
		ConfigManager.load();
		
		
		//コアスクリプト変更に伴って修正
		this.loadSystemWindowImage();
		//this.loadSystemImages();
		
		this.loadOriginalImages();
	};
	
	//オリジナルロード（開始直後にロードしておく）
	Scene_Boot.prototype.loadOriginalImages = function(){
    	ImageManager.loadFace('Benjomin');
    	ImageManager.loadFace('BenjominOld');
    	ImageManager.loadFace('Bahunmal');
    	ImageManager.loadFace('Seimei');
    	ImageManager.loadFace('Seimei_Old');
    	ImageManager.loadFace('Shit');
    	ImageManager.loadFace('ShitMal');
    	ImageManager.loadFace('StoolSmall');
    	ImageManager.loadFace('Toile');
	}
	


	//===========
	//Window_Command 再定義
	//=============
	
	//横幅の書き換え
	Window_MenuCommand.prototype.windowWidth = function(){
		return 816;
	};
	//縦幅の書き換え
	Window_MenuCommand.prototype.windowHeight = function(){
		return 120;
	};
	
	Window_MenuCommand.prototype.maxCols = function(){
		return 4;
	}
	
	Window_MenuCommand.prototype.numVisibleRows = function(){
		return 1;
	}

	//文字の高さを設定だと思う
	Window_MenuCommand.prototype.lineHeight = function(){
		return 81;
	}
	
	//メインコマンドの再定義（すべて削除)
	Window_MenuCommand.prototype.addMainCommands = function() {
   		// var enabled = this.areMainCommandsEnabled();
    	/*if (this.needsCommand('item')) {
    	    this.addCommand(TextManager.item, 'item', enabled);
    	}
    	/*if (this.needsCommand('skill')) {
    	    this.addCommand(TextManager.skill, 'skill', enabled);
    	}*/
    	/*if (this.needsCommand('equip')) {
    	    this.addCommand(TextManager.equip, 'equip', enabled);
    	}*/
    	/*if (this.needsCommand('status')) {
    	    this.addCommand(TextManager.status, 'status', enabled);
    	}*/
	};

	
	//メニューに追加するコマンド群
	Window_MenuCommand.prototype.makeCommandList = function(){
		this.addMainCommands();
		this.addSaveCommand();
		this.addOptionsCommand();
		this.addGameEndCommand();
		this.addCommand('戻る','return',true);//オリジナル選択肢、戻るの追加
	};
	
	//=====================
	//Window_Gold再定義
	//=====================
	
	//高さの変更
	Window_Gold.prototype.windowHeight = function() {
    	return 78;
	};

	
	//=====-
	//Window_Baseメソッド追加
	//===========
	
	//画像の描画
	//imgフォルダ内にあるフォルダの名前の指定、
	//画像名の指定(拡張子抜き)、読み込む画像の開始X座標、
	//読み込む画像の開始Y座標、描写位置X座標、描写位置Y座標、幅、高さ
	Window_Base.prototype.drawPicture = function(dir,filename,sx,sy,x,y,w,h,hue){
		
		var bitmap = ImageManager.loadBitmap('img/' + dir + '/',filename,hue,true);
		
		this.contents.blt(bitmap,sx,sy,w,h,x,y);
	};
	
	Window_Base.prototype.drawActorsStatus_t = function(ac){
	
        var w = 144;
        var h = 144;

        var ww = Graphics.width / 4;
		var wh = Graphics.height - 240;

		//人数分の描画
		for(var i = 0; i < $gameParty.size();i++){
		
		//名前
		ac[i].drawText($gameParty.battleMembers()[i]._name,0,0);
		//職業
		ac[i].drawText($gameParty.members()[i].currentClass().name,0,wh - ac[i].fittingHeight(1));
		
		//顔グラ,歩行を拡大させるか、別の画像を用意して、表示させる
		ac[i].drawPicture("faces",$gameParty.members()[i].faceName(),0,0,10,ac[i].fittingHeight(2),w,h);
		}
	};
	


	//=======================================
	//Scene_Menu　の再定義
	//=======================================

	//wolfメニューの作成
	Scene_Menu.prototype.create = function(){
		Scene_MenuBase.prototype.create.call(this);
		//それぞれのメニュー
		    this.createCommandWindow();
  	  		this.createStatusWindow();
			this.createHeadLineWindow();
	};

    // load bitmap that set in plugin parameter flom AltMenuScene2 Yoji Ojima
    var _Scene_Menu_createBackground = Scene_Menu.prototype.createBackground;
    Scene_Menu.prototype.createBackground = function(){
        if(backGroundBitmap){
            this._backgroundSprite = new Sprite();
 			
 			//バックをランダムで
            var rand = Math.floor(Math.random() * 4);//乱数
            if(rand >= 1 && $gameVariables.value(StoryValue) < 2) rand = 0;//シット解放前に出たらベンにする
            if(rand >= 2 && $gameVariables.value(StoryValue) < 10) rand = Math.floor(Math.random() * 2);//セイメイ解放前にでたらベンかｼｯﾄに
 
            this._backgroundSprite.bitmap =
             ImageManager.loadPicture(backGroundBitmap[rand]);

            this.addChild(this._backgroundSprite);
            return;
        }
        // if background file is invalid, it does original process.
        _Scene_Menu_createBackground.call(this);
    };

Scene_Menu.prototype.createCommandWindow = function() {
    this._commandWindow = new Window_MenuCommand(0, 504);
 /*   this._commandWindow.setHandler('item',      this.commandItem.bind(this));
    this._commandWindow.setHandler('skill',     this.commandPersonal.bind(this));
    this._commandWindow.setHandler('equip',     this.commandPersonal.bind(this));
    this._commandWindow.setHandler('status',    this.commandPersonal.bind(this));
    this._commandWindow.setHandler('formation', this.commandFormation.bind(this));
   */
    this._commandWindow.setHandler('options',   this.commandOptions.bind(this));
    this._commandWindow.setHandler('save',      this.commandSave.bind(this));
    this._commandWindow.setHandler('gameEnd',   this.commandGameEnd.bind(this));
    this._commandWindow.setHandler('cancel',    this.popScene.bind(this));
 	//オリジナルコマンド、リターンでメニューを閉じる
	this._commandWindow.setHandler('return',this.popScene.bind(this));
    this.addWindow(this._commandWindow);
};

Scene_Menu.prototype.createStatusWindow = function() {
    this._statusWindow = new Window_MenuStatus(this._commandWindow.width, 0);
    this.addWindow(this._statusWindow);

		//ウィンドウの幅と高さの決定
		state_width = Graphics.width / 4;
		state_height =( Graphics.height - 240);
					
		//ウィンドウの生成１つの配列に情報を保持
		var ac = [
			new Window_Base(state_width * 0,120,state_width,state_height),
			new Window_Base(state_width * 1,120,state_width,state_height),
			new Window_Base(state_width * 2,120,state_width,state_height),
			new Window_Base(state_width * 3,120,state_width,state_height),
		];
		
		
		//ウィンドウの追加
		for(var i = 0; i < ac.length ; i++){		
			this.addWindow(ac[i]);
		}		
		
		//オリジナルメソッドでキャラクターのステータスを描画
		Window_Base.prototype.drawActorsStatus_t(ac);

};

	//見出しの表示
	Scene_Menu.prototype.createHeadLineWindow = function(){
		this._headLineWindow = new Window_Base(0,0,816,120);
		this._headLineWindow.drawText("キャラクター",816 / 2 - 86,30);
		this.addWindow(this._headLineWindow);

	}




})();
