//=================================================================
// Wolf_OutSideSerif.js
// Copyright(c) 2016 Wolf
//-----------------------------------------------------------------
// Varrion
// 0.8.1 表示を上下に切り替え可能に
// 0.8.2 コメント等整理、ファイル名変更
// 0.8.3 フラグ名　lower を　upper に変更
// 0.8.5 動的に表示位置の取得、ズーム率でｘ座標を修正
// 0.9.1 メインテキストが消えると、消せるように変更（がんばった！、Game_Message に変数追加したけど...）　
//		　ついでに 引数でfalse true を判定できなかった不具合を修正
// 0.9.2 X座標がずれていたので左にすこし修正
// 0.9.3 ベースウィンドウのポジションを常時リセットするように
// 0.04 IOSでうまく表示されないバグを修正、てかなんでIOSでwindow.innerhoge でほしい値がとれないんですかねぇ・・・
//-----------------------------------------------------------------

/*:ja
*@plugindesc メインのセリフ以外のセリフを表示させる
*@author うるふ
*Copyright 2016 うるふ
*
*プラグインコマンド
* {eventId} のイベントに {TEXT}の内容を表示させる
* OSS {eventId} {TEXT}
*
* セリフを上に表示
* OSS {eventId} {TEXT} {true}
* 
* {eventId} の表示しているセリフを消す
* OSS_SPE_DELERE {eventId}
*
* すべてのセリフを消す
* OSS_ALL_DELETE
*
*メインテキストとの紐づけ、Wait がなければ、他の処理を挟んでも実行できそう
*/


	//==================
	//プラグインコマンド
	//==================

	var _Game_Interpreter_pluginCommand = Game_Interpreter.prototype.pluginCommand;
	Game_Interpreter.prototype.pluginCommand = function(command,args){
		_Game_Interpreter_pluginCommand.apply(this,arguments);
		try{
			this.pluginCommandOSS(command,args);
		}catch(e){
			if($gameTemp.isPlaytest() && Utils.isNwjs()){
				var window = require('nw.gui').Window.get();
				if(!window.isDevToolsOpen()){
					var devTool = window.showDevTools();
					devTool.moveTo(0,0);
					devTool.resizeTo(Graphics.width, Graphics.height);
					window.focus();
				}
			}
			console.log('プラグインコマンド実行エラー');
			console.log('- コマンド名 :' + command);
			console.log('- コマンド引数 :' + args);
			console.log('- エラー原因 :' + e.toString());
			
		}
	};
	
	Game_Interpreter.prototype.pluginCommandOSS = function(command,args){
		
		switch(command)
		{
		case 'OSS':
			//console.log("Boolean Test = " + Boolean(args[2]));//テキストだったらfalse でもtrue を返される
			var boolUpeer = (args[2] === "true") ? true : false;//引数が文字としてtrue ならtrueに変換し、引数に代入
			var boolDell = (args[3] === "true") ? true : false;//引数が文字としてtrue ならtrueに変換し、引数に代入
			$gameSystem.setOSSWindow(Number(args[0]),String(args[1]),boolUpeer,boolDell);
			break;
		case 'OSS_ALL_DELETE':
			$gameSystem.allRisetOSSData();
			break;
		case 'OSS_SPE_DELETE':
			$gameSystem.specifiedRisetOSSData(Number(args[0]));
			break;
		}

	};

	// ===========================
	// $gameMessage を追加定義
	// ===========================
	

	//addFlag を追加し、テキストが表示されたか取得する
	var _Game_Message_clear = Game_Message.prototype.clear;
	Game_Message.prototype.clear = function(){
		_Game_Message_clear.call(this);
		this._addFlag = false;
	}



	var _Game_Message_add = Game_Message.prototype.add;
	Game_Message.prototype.add = function(){
		_Game_Message_add.apply(this,arguments);
		this._addFlag = true;
	}

	//===========================
	//OSSウィンドウデータクラス
	/////////////////////////////
	
	function OSS_Data(id,text,px,py,upper,dell){
	
		this._eventId = id;
		this._text = text;

		this._x = px;
		this._y = py;

		this._upper = upper;

		this._dell = dell;

		this._addY = 0;//ｙ座標加算回数値、被り回避用

	}

	//日本語を2,英語を1で文字列を計算
	function lengthText(str){
		var len = 0;
		str = escape(str);
		for(i =  0 ; i < str.length ; i++){

			if(str.charAt(i) == "%"){
				if(str.charAt(++i) == "u"){
					i += 4;
					len++;
				}
			}

			len++;
		}
		return len;
	}
	
	//==========================
	//Game_System
	//ウィンドウ情報を保持します
	//==========================
	
	var _Game_System_initialize = Game_System.prototype.initialize;
	Game_System.prototype.initialize = function(){
		_Game_System_initialize.apply(this,arguments);
		
		//データ
		this._OSS_Data = new Array();


	};
	
	Game_System.prototype.setOSSWindow = function(id,text,upperFlag,dellFlag){
		//console.log("flag = " + upperFlag);

		//引数がなければfalseに設定
		if(upperFlag == undefined){
			upperFlag = false;
		}


		if(id > 1){
			var x = $gameMap.event(id).screenX() - 4;
			var y = $gameMap.event(id).screenY();
		}
		else{
			var x = $gamePlayer.screenX() - 4;
			var y = $gamePlayer.screenY();

		}

		y -= 4;//少し調整

		//下表示の場合座標を修正
		if(upperFlag){
			y -= 96 + 24;
		}
/*
		//同じイベントからのセリフがあれば前のセリフを削除する
		for(var i = 0 ; i < this._OSS_Data.length ; i++){
			if(this._OSS_Data[i]._eventId == id){
				this._OSS_Data.splice(i,1);
				continue;
			}
			//同じｙ座標に他のセリフがあれば下に下げていく
			if(this._OSS_Data[i]._y == y){
				y += 30;
			}
		}
*/
		//同じイベントからのセリフがあれば前のセリフを削除する
		for(var i = 0 ; i < this._OSS_Data.length ; i++){
			if(this._OSS_Data[i]._eventId == id){
				this._OSS_Data.splice(i,1);
				continue;
			}
			var datay = this._OSS_Data[i]._y + 30 * this._OSS_Data[i]._addY;

			//同じｙ座標に他のセリフがあれば下に下げていく
			if(datay == y){
				this._OSS_Data[i]._addY += 1;
			}
		}

		//配列を追加
		this._OSS_Data.push(new OSS_Data(id,text,x,y,upperFlag,dellFlag));
		

		
	};
	
		
	Game_System.prototype.setOSSWindowPosition = function(px,py,num){

		this._OSS_Data[num]._x = px;
		this._OSS_Data[num]._y = py;
	}
	
	Game_System.prototype.getOSSData = function(){
	
		return this._OSS_Data;
	}
	
	//すべての配列のリセット
	Game_System.prototype.allRisetOSSData = function(){
		this._OSS_Data = [];
	}
	
	//指定したイベントのセリフを消す
	Game_System.prototype.specifiedRisetOSSData = function(id){
	
		for(var i = 0 ; i < this._OSS_Data.length ; i++){
			if(this._OSS_Data[i]._eventId == id){
				this._OSS_Data.splice(i,1);
			}
		}
	}

	//===========================-
	//オブジェクト生成
	//===========================-
	
	var _Game_Interpreter = new Game_Interpreter();
	
	//============================
	//Scene_Map
	//OutSideSerif のウィンドウを作成します
	//============================
	
	var _Scene_Map_start = Scene_Map.prototype.start;
	Scene_Map.prototype.start = function(){
		_Scene_Map_start.call(this);
		this._OSSWindow = new Window_OSS();
		this.addWindow(this._OSSWindow);
	}
	
	var _Scene_Map_update = Scene_Map.prototype.update;
	Scene_Map.prototype.update = function(){
		_Scene_Map_update.call(this);
		this._OSSWindow.update();
	
	}

	
	//========================
	//Windowの作成
	//セリフを表示させるウィンドウ
	//========================
	
	function Window_OSS(){
		this.initialize.apply(this,arguments);
	}
	
	Window_OSS.prototype = Object.create(Window_Base.prototype);
	Window_OSS.prototype.constructor = Window_OSS;
	
	Window_OSS.prototype.initialize = function(){
	

		//セリフが0座標になるようにウィンドウを調整
		var wx = -15;
		var wy = -15
		
		//IOSでうまく取得できないので削除
		//var ww = window.innerWidth + 30;
		//var wh = window.innerHeight + 30;
		
		var ww = 816 + 30;
		var wh = 624 + 30;

		Window_Base.prototype.initialize.call(this,wx,wy,ww,wh);
		
		//よくわからいけど重なった後ろのウィンドウを消さないようにする
		this._isWindow = false;
		
		this.color = 'rgba(50,50,50,0.8)';
		//console.log("font = " + this.lineHeight());
		
		this.clear();
	
		//表示データの配列
		this._OSS_Data = new Array();
		
		//イベント終了後消すフラグ
		this._isRiset = false;
		

	};
	
	
	Window_OSS.prototype.clear = function(){
		this.opacity = 0;
	};
	
	//更新
	Window_OSS.prototype.update = function(){
	
		this.refresh();
		
		this._OSS_Data = $gameSystem.getOSSData();
		
		for(var i = 0 ; i < this._OSS_Data.length ; i++){
			//削除フラグ
			this._isEvent = true;
					
			var text = this._OSS_Data[i]._text;
			this.setPosition(i);//動的に位置を変更（ズーム関係）　（ｙ座標修正未対応)

			this.drawSerif(text,i);

			this.dellTextEnd(i);//メインテキスト終了時にデータを削除する処理

		}
	this.risetEventOut();
		
		
	};

	//ウィンドウのリセット
	Window_OSS.prototype.setWindow = function(){
		this.x = -15;
		this.y = -15;
	};
	
	Window_OSS.prototype.centerX = function(x,width){
		return x - width / 2;
	};
	
	Window_OSS.prototype.drawOSSText = function(x,y,text){
			
//		var tx = this.centerX(x,text.length * this.standardFontSize());
		var tx = this.centerX(x,lengthText(text) * this.standardFontSize() / 2);
		var ty = y + this.selifTopHeight();

		this.contents.textColor = 10;;
		this.drawTextEx(text,tx,ty);
	
	};
	
	Window_OSS.prototype.drawOSSBack = function(x,y,w,h){
	
		//var bx = $gameSystem.getOSSWindowPositionX();
		var bx = this.centerX($gameSystem.getOSSWindowPositionX(),w);
		var by = $gameSystem.getOSSWindowPositionY();
		
		var bw = w;
		var bh = h;
		
		this.contents.gradientFillRect(bx,by,bw,bh,this.color,this.color);
	
	}

	Window_OSS.prototype.drawOSSPicture = function(x,y,width){

		var px = this.centerX(x,width + 15);
		var py = y + this.selifTopHeight() - 3;

				
		//メニュー作成のプラグインを使っている
		this.drawPicture("system","OutSideSerif_Img",0,0,px,py,width,35,90);
		this.drawPicture("system","OutSideSerif_Img",816 - 15,0,px + width,py,15,35,90);
	
	};

	Window_OSS.prototype.drawOSSPictureIcon = function(x,y,upper){

		var addY = 0;
		var startX = 0;

		//上と下表示で座標を修正
		if(upper){
			addY = 48 + 3;

			//上表示なら画像切り取り座標を変更
			startX = 24;	
		}

		else{
			addY = 5;
		}

		var px = this.centerX(x,24);
		var py = y + addY;

		this.drawPicture("system","OutSideSerifTop_Img",startX,0,px,py,24,24,90);

	}
	
	Window_OSS.prototype.drawSerif = function(text,num){
	
		//var sw = text.length * this.standardFontSize() + 20;
		var sw = lengthText(text) * this.standardFontSize() / 2 + 20;
		
		var sx = this._OSS_Data[num]._x;
		var sy = this._OSS_Data[num]._y;
		var upperFlag = this._OSS_Data[num]._upper;
		
		this.drawOSSPicture(sx,sy,sw);
		this.drawOSSPictureIcon(sx,sy,upperFlag);
		this.drawOSSText(sx,sy,text);

	
	};

	//ズーム時、trueを返す
	Window_OSS.prototype.isZoom = function(){
		return ($gameScreen.zoomScale() > 1) ? true : false;
	//	return ($gameMap.cameraScale > 1) ? true : false;
	}

	//イベント番号からキャラクターを返す
	Window_OSS.prototype.getCharacter = function(id){
		if(id == -1){
			return $gamePlayer;
		}
		else{
			return $gameMap.event(id);
		}
	}

	//データのポジションを変更する
	Window_OSS.prototype.setPosition = function(num){

		var character = this.getCharacter(this._OSS_Data[num]._eventId);//キャラクターを取得

		var x = (character.screenX() - 4) * $gameScreen.zoomScale();//ズーム率で修正
		var y = character.screenY() * $gameScreen.zoomScale();
	//	var x = character.screenX() * $gameMap.cameraScale;//ズーム率で修正
	//	var y = character.screenY() * $gameMap.cameraScale;
		//ｙ軸修正
		y -= 4;//少し調整

		//下表示の場合座標を修正
		if(this._OSS_Data[num]._upper){
			y -= 96 + 24;
		}

		y = y + 30 * this._OSS_Data[num]._addY;//被り分の座標を修正

		this._OSS_Data[num]._x = x;
		this._OSS_Data[num]._y = y;

	}

	//メインテキストの表示が終わると、dellフラグが経っているデータを削除する
	Window_OSS.prototype.dellTextEnd = function(num){

		//Game_Message からテキストが消えたことを取得
		if($gameMessage._addFlag == false){

			if(this._OSS_Data[num]._dell == true){
				this._OSS_Data.splice(num,1);
			}

		}

	}

	//イベントが終わったらデータを削除する
	Window_OSS.prototype.risetEventOut = function(){
	
		if(!$gameMap.isEventRunning() && this._isEvent){
			this._isEvent = false;
			$gameSystem.allRisetOSSData();
		}
	
	}
	
	Window_OSS.prototype.standardFontSize = function() {
    	return 24;
	};
	
	Window_OSS.prototype.lineHeight = function(){
		return 30;
	}

	Window_OSS.prototype.selifTopHeight = function(){
		return 22;
	}

	
	Window_OSS.prototype.refresh = function(){
		this.contents.clear();
		//サイズをウィンドウに合わせる(IOSでうまく取得できなかったので削除)
		/*
		if(this.width != window.innerWidth + 30){
			this.width = window.innerWidth + 30;
		}
		if(this.height != window.innerHeight + 30){
			this.height = window.innerHeight + 30;
		}
		*/
		this.setWindow();
	};


	
	
	
