﻿//----------------------------------------------------------------
// Varsion
// 0.7.0 2016_12_13 基本完成
// 0.7.0 2016_12_14	SEの再生
//----------------------------------------------------------------
/*:ja
*@plugindesc 影の舞いの攻撃
*@author うるふ
*
*@param Unknown Date
*@desc プロトタイプ
*default 不明
*
*@help
*
*影の舞いの攻撃
*
*
*
*/



(function() {

	//==================================
	//オブジェクト生成
	//==================================

	function WolfEffect_SA(){
		this.initialize.call(this);

	}


	//ゲームベースを継承
	WolfEffect_SA.prototype = Object.create(WolfGame_Base.prototype);
	WolfEffect_SA.prototype.constructor = WolfEffect_SA;


	//==================================
	//変数
	//==================================



	//==================================
	// プラグインパラメータ取得
	//==================================

	//パラメータ取得するときに使用
	var Parameters = PluginManager.parameters('Wolf_EffectSA');

	//=======================================
	// WolfEffect_SA メソッド
	//=======================================

	//=============================-
	// ゲーム基本メソッド
	//=============================-

	WolfEffect_SA.prototype.initialize = function(){
		WolfGame_Base.prototype.initialize.call(this);
		
		this._posiChar = [-100,312];//攻撃キャラ
		this._spdChar = 40;
		this._indexChar = 0;

		this._flagFlash = false;

		this._charName = [ "Bah" , "Shi" , "Sei" , "Ben"];

		//se file name
		this._seAttack = "Slash1";
		this._seAttackBen = "Skill3";

	}

	WolfEffect_SA.prototype.risetAll = function(){
		this._indexChar = 0;

		this._flagFlash = false;
		
	}

	WolfEffect_SA.prototype.set = function(){
		WolfGame_Base.prototype.set.call(this);
		this.risetAll();
		this.draw();
	};


	WolfEffect_SA.prototype.main = function(){
		WolfGame_Base.prototype.main.call(this);
		this.update();
		this.draw();

	};

	WolfEffect_SA.prototype.end = function(){
		WolfGame_Base.prototype.end.call(this);
	}


	//=============================-
	// ゲーム更新関係
	//=============================-

	WolfEffect_SA.prototype.update = function(){
		this.updateAttackChar();
		this.checkOutChar();
	}

	WolfEffect_SA.prototype.updateAttackChar = function(){
		this._posiChar[0] += this._spdChar;

		if(this._posiChar[0] >= 408 && this._flagFlash == false){
			this.effectFlash();
		}
	}

	//キャラが画面外にいくとまた左から次のキャラになり、でてくる
	WolfEffect_SA.prototype.checkOutChar = function(){
		var add = 100;

		//ラスト、ベンだけ少し遅れて出てくる
		if(this._indexChar >= 2){
			add = 1000;
		}
		if(this._posiChar[0] >= 816 + add){
			this._posiChar[0] = -40;
			this._indexChar += 1;
			this._flagFlash = false;
		}

		this.endGame(this._indexChar);

	}

	WolfEffect_SA.prototype.endGame = function(index){
		if(index >= 4){
			WolfGame_Base.prototype.onEndSwitche.call(this);
		}
	}

	WolfEffect_SA.prototype.effectFlash = function(){
		if(this._indexChar == 3){
			WolfGame_Base.prototype.playSe(this._seAttackBen);//SEの再生
		}else{
			WolfGame_Base.prototype.playSe(this._seAttack);//SEの再生

		}
		$gameScreen.startFlash([255,255,255,170],30);
		this._flagFlash = true;
	}

	//=============================-
	// ゲーム描画関係
	//=============================-

	WolfEffect_SA.prototype.draw = function(){
		WolfGame_Base.prototype.draw.call(this);
		this.drawBackGround(1);
		this.drawEnemy(2);
		this.drawAttackChar(3);
	}

	WolfEffect_SA.prototype.drawBackGround = function(id){
		$gameScreen.showPicture(id,"Effect_ShadowBack",0,0,0,100.0,100.0,255,0);	

	}

	WolfEffect_SA.prototype.drawAttackChar = function(id){
		if(this._indexChar < 4){
		var fileName = "Effect_Gray" + this._charName[this._indexChar];
			$gameScreen.showPicture(id,fileName,1,this._posiChar[0],this._posiChar[1],200.0,200.0,255,0);	//仮画像
		}
	}

	WolfEffect_SA.prototype.drawEnemy = function(id){
		$gameScreen.showPicture(id,"Effect_GrayKUSOFER",1,408,312,200.0,200.0,255,0);	//仮画像
	}

	//=============================-
	// ゲーム終了関係
	//=============================-
	
	//=========================================
	//オブジェクト生成
	//=========================================
	var _WolfEffect_SA = new WolfEffect_SA();


	//=========================================
	// プラグインコマンドで制御
	//=========================================

	var _Game_Interpreter_pluginCommand = Game_Interpreter.prototype.pluginCommand;
	Game_Interpreter.prototype.pluginCommand = function(command,args)
	{
		_Game_Interpreter_pluginCommand.call(this,command,args);

		if(command === 'Wolf_EffectSA'){

			switch (args[0])
			{
			case 'set':
				_WolfEffect_SA.set();
				console.log("set");
				
				break;			

			case 'main':
				_WolfEffect_SA.main();
				break;
			case 'end':
				_WolfEffect_SA.end();
				break;			
	
			}
		}

	};
		




})();
