﻿//----------------------------------------------------------------
// Varsion
// 0.3.0 2016_12_11 基本系統の作成
//					ターンゲームの基本完成
//					シーン切り替え
//					チョコの表現
// 0.6.0 2016_12_12 ポァーゲームの基本完成
//					メーターの作成
//					気合マークが動的に増減できるように
//					気合マークをベジュる
//					プットゲームの基本完成
//					すべてのゲームを通しでできるように
//					ポァーゲーム、外すと初めからに変更
// 0.6.1 2016_12_13 WolfGame_Base 変更に伴い、ピクチャの最大、最小の変数を削除
//					グッド、バッドエフェクトの追加
// 0.6.3 2016_12_14 SEの追加
//					BGMの追加
//
//----------------------------------------------------------------
/*:ja
*@plugindesc 合体ゲーム
*@author うるふ
*
*@param Unknown Date
*@desc プロトタイプ
*default 不明
*
*@help
*
*合体ゲーム
*
*
*
*/



(function() {

	//==================================
	//オブジェクト生成
	//==================================

	function WolfGame_Unite(){
		this.initialize.call(this);


	};

	//ゲームベースを継承
	WolfGame_Unite.prototype = Object.create(WolfGame_Base.prototype);
	WolfGame_Unite.prototype.constructor = WolfGame_Unite;


	//==================================
	//変数
	//==================================

	//座標の構造体
	function Point(x,y){
		this.x = x;
		this.y = y;
	}


	//==================================
	// プラグインパラメータ取得
	//==================================

	//パラメータ取得するときに使用
	var Parameters = PluginManager.parameters('Wolf_UniteGame');

	//=======================================
	// WolfGame_Unite メソッド
	//=======================================

	WolfGame_Unite.prototype.initialize = function(){
		WolfGame_Base.prototype.initialize.call(this);

		//this._minPicId = 1;
		//this._maxPicId = 30;

		this._gameScene = 0;

		this._timeCount = 0;


		//Turn Game
		this._posiArow = [ 	[408 , 492],
							[100 , 312],
							[408 , 102],
							[716 , 312]];//矢印の座標
		this._arowIndex = 0;
		this._machCount = 0;
		this._turnBorder = 8;

		//Pour Game
		this._posiBowl = [408 , 115];//ボウルの座標
		this._posiChoco = [-100,-100];
		//this._spdChoco = 5;
		
		//this._addXChoco = 0;
		this._acceleChoco = 0.2;//加速度
		this._acceleCount = 0;//加速時間

		this._actBowl = true;
		this._timeBowlMax = 120;
		this._timeBowlNow = this._timeBowlMax;//現在のボウル移動時間
		this._timeBowl = this._timeBowlMax;//ボウルの移動時間
		this._powerBowl = 408;//ボウルの移動幅


		this._inputCount = 0;//チョコを入れた回数
		this._pourBorder = 3;

		//Put Game
		this._fight = []//気合、２次元配列 

		this._timeBezi = 60;//ベジュする時間

		this._quonFight = 0;
		this._quonFightSave = 0;
		this._maxFight = 100;
		this._addFight = 2.5;

		//se file name
		this._seMiss = "Disappointment";
		this._seGood = "Item3";
		this._seTurn = "water-stop1";
		this._seChoco = "choco";
		this._seFight = "mens-ou1";
		this._seFanFare = "correct1";

		//bgm file name
		this._bgm = "Crazy_Cooking";
	};

	//=============================-
	// ゲーム初期化関係
	//=============================-

	WolfGame_Unite.prototype.risetAll = function(){
		this.risetTurn();
		this.risetPour();
		this.risetPut();
		this._gameScene = 0;

	};

	//=============================-
	// ゲーム初期化関係 - Turn -
	//=============================-

	WolfGame_Unite.prototype.risetTurn = function(){
		this.risetTurnArow();
	}

	WolfGame_Unite.prototype.risetTurnArow = function(){
		this._arowIndex = 0;
		this._machCount = 0;
	};

	//=============================-
	// ゲーム初期化関係 - Pour -
	//=============================-

	WolfGame_Unite.prototype.risetPour = function(){
		this.risetPourBowl();
		this.risetPourChoco();
		this._inputCount = 0;
		this._indexFile = 0;
	}

	WolfGame_Unite.prototype.risetPourBowl = function(){
		this._posiBowl[0] = 408;
		this._actBowl = true;
		this._timeBowl = this._timeBowlMax;
		this._timeBowlNow = this._timeBowlMax;
	}

	WolfGame_Unite.prototype.risetPourChoco = function(){
		for(var i = 0 ; i < 2 ; i++){
		this._posiChoco[i] = -100;
		}
		this._addXChoco = 0;
		this._acceleCount = 0;
	}

	//=============================-
	// ゲーム初期化関係 - Put -
	//=============================-

	WolfGame_Unite.prototype.risetPut = function(){
		this.risetPutFight();
	}

	WolfGame_Unite.prototype.risetPutFight = function(){
		this._fight = [];
		this._quonFight = 0;
		this._quonFightSave = 0;

	}

	//ファイト配列に新しいデータを入れる  （ベジュに必要な初期座標、方向点、最終座標を引数にもつ
	WolfGame_Unite.prototype.pushFight = function(sx,sy,dx,dy,ex,ey){
		this._fight.push( [new Point (sx,sy) , new Point(sx,sy) , new Point(dx,dy) , new Point(ex,ey) , 0] );
		//this.addMaxPicId(1);


	}

	//=============================-
	// ゲーム基本メソッド
	//=============================-

	WolfGame_Unite.prototype.set = function(){
		WolfGame_Base.prototype.set.call(this);
		WolfGame_Base.prototype.playBgm.call(this,this._bgm);

		this.risetAll();
		//this.draw();
	};

	WolfGame_Unite.prototype.setGameScene = function(num){
		this._gameScene = num;
	}


	WolfGame_Unite.prototype.main = function(){
		WolfGame_Base.prototype.main.call(this);
		this.update();
		this.draw();

	};

	WolfGame_Unite.prototype.end = function(){
		WolfGame_Base.prototype.end.call(this);
	}


	//=============================-
	// ゲーム更新関係
	//=============================-

	WolfGame_Unite.prototype.update = function(){
		this.chooseUpdateScene();

	
	}

	//シーンによってアップデートメソッドを選ぶ
	WolfGame_Unite.prototype.chooseUpdateScene = function(){

		switch(this._gameScene){
			case 0:
				this.updateTurnGame();
				break;
			case 1:
				this.updatePourGame();
				break;
			case 2:
				this.updatePutGame();
				break;

			}
	}

	//一旦進めさせないように
	WolfGame_Unite.prototype.forwardScene = function(){
		//this._gameScene += 1;
		WolfGame_Base.prototype.onEndSwitche.call(this);//ゲームを終了させる

	}

	WolfGame_Unite.prototype.updateTime = function(){
		this._timeCount += 1;
	}

	//=============================-
	// ゲーム更新関係 - Turn - 
	//=============================-

	WolfGame_Unite.prototype.updateTurnGame = function(){

		this.updateTurnDrag();
		this.updateTurnKey();
		this.turnGameCria();
	}

	WolfGame_Unite.prototype.updateTurnDrag = function(){

		var dier = $gameSystem.wolfReturnDragDier();
		
		this.checkTurnOk(dier,TouchInput.x,TouchInput.y);
	}

	//キーでも対応させる
	WolfGame_Unite.prototype.updateTurnKey = function(){

		var key = $gameSystem.wolfReturnIsTriggeredCursorKey()
		var num = this._arowIndex;
		this.checkTurnOk(key,this._posiArow[num][0],this._posiArow[num][1]);

	}

	//入力方向が指定方向かチェック、エフェクトの表示
	WolfGame_Unite.prototype.checkTurnOk = function(dier,x,y){
	
		if(dier != ""){
	
			//ドラッグ方向と、矢印の方向があっていれば進む
			if(this.checkTurnDragArow(dier,this._arowIndex)){
				this.changeTurnArow();
				WolfGame_Base.prototype.playSe(this._seTurn);//SEの再生
				WolfGame_Base.prototype.criateMarkEffect.call(this,x,y,"GOOD");//エフェクト			

			}else{
			WolfGame_Base.prototype.playSe(this._seMiss);//SEの再生
				WolfGame_Base.prototype.criateMarkEffect.call(this,x,y,"BAD");//エフェクト			
			}
		
		}
	}

	//矢印の方向を切り替える
	WolfGame_Unite.prototype.changeTurnArow = function(){
		this._arowIndex = (this._arowIndex + 1) % 4;
		this._machCount += 1;
	}

	//ドラッグ方向が、矢印と合っているか検証
	WolfGame_Unite.prototype.checkTurnDragArow = function(drag,index){

		var check = false;

		switch(index){
			case 0:
				if(drag == "LEFT"){
					check = true;
				}
			break;
			case 1:
				if(drag == "UP"){
					check = true;
				}
			break;
			case 2:
				if(drag == "RIGHT"){
					check = true;
				}
			break;
			case 3:
				if(drag == "DOWN"){
					check = true;
				}
			break;

		}
		return check;
	}

	//ターンゲームを終わらせる
	WolfGame_Unite.prototype.turnGameCria = function(){
		if(this._machCount >= this._turnBorder){
//			WolfGame_Base.prototype.onEndSwitche.call(this);
			this.forwardScene();

		}
	}

	//=============================-
	// ゲーム更新関係 - Pour - 
	//=============================-

	WolfGame_Unite.prototype.updatePourGame = function(){

		if(this._actBowl){
			this.updatePourInput();
			this.updatePourBowl();
		}else{
			this.updatePourChoco();
		}
	}

	WolfGame_Unite.prototype.updatePourBowl = function(){
			this._timeBowlNow = Math.min(this._timeBowlNow + 1 , this._timeBowl)
			this._posiBowl[0] = this._powerBowl * Math.sin(Math.PI * 2 / this._timeBowlNow * this._timeCount) + 408;
			this.updateTime();
	}

	WolfGame_Unite.prototype.updatePourInput = function(){
		if($gameSystem.wolfIsTriggeredOkorTouch()){
			WolfGame_Base.prototype.playSe(this._seChoco);//SEの再生
			this._actBowl = false;
			this.setChoco();
		}
	}


	WolfGame_Unite.prototype.updatePourChoco = function(){
		this.accelerPourChoco();
		this._posiChoco[1] += this._addXChoco;
	
		if(this.checkPourChocoDown()){
	
			//ちょこが入ったかどうか
			if(this.checkCollisionChoco()){
				this.forwardPourGame();
				WolfGame_Base.prototype.criateMarkEffect.call(this,this._posiChoco[0],312 + 50,"GOOD");//エフェクト			


			}else{
				//WolfGame_Base.prototype.onEndSwitche.call(this);
				WolfGame_Base.prototype.playSe(this._seMiss);//SEの再生
				WolfGame_Base.prototype.criateMarkEffect.call(this,this._posiChoco[0],312 + 50,"BAD");//エフェクト			

				this.risetPour();

			}

		}
	}


	WolfGame_Unite.prototype.accelerPourChoco = function(){
		this._addXChoco = this._acceleChoco * this._acceleCount;

		this._acceleCount += 1;
	}

	WolfGame_Unite.prototype.setChoco = function(){
		this.risetPourChoco();
		this._posiChoco[0] = this._posiBowl[0]  - 250 / 2 - 15;
		this._posiChoco[1] = this._posiBowl[1] - 352 / 2 + (332 * 0.15);
	}

	//チョコが下までいったかチェックする
	WolfGame_Unite.prototype.checkPourChocoDown = function(){
		if(this._posiChoco[1] - 352 / 2 >= 624){
			return true;
		}
		else{
			return false;
		}
	}

	//ゲームを進める
	WolfGame_Unite.prototype.forwardPourGame = function(){
		this._actBowl = true;
		this.upBowlSpped();
		this.forwardPourInput(1);
		WolfGame_Base.prototype.playSe(this._seGood);//SEの再生
		
	}

	//スピードアップ
	WolfGame_Unite.prototype.upBowlSpped = function(){
		this._timeBowl -= 30;
	}

	//ゲーム進行処理
	WolfGame_Unite.prototype.forwardPourInput = function(add){
		this._inputCount += add;

		if(this._inputCount >= this._pourBorder){
//				WolfGame_Base.prototype.onEndSwitche.call(this);
				this.forwardScene();
		}

	}

	//チョコと型が接触しているかどうか
	WolfGame_Unite.prototype.checkCollisionChoco = function(){
		var x = Math.abs(this._posiChoco[0] - 408);
		var size = (80 +  350) / 2;
		if(x < size ){
			return true;
		}
		else{
			return false;
		}
	}


	//=============================-
	// ゲーム更新関係 - Put - 
	//=============================-

	WolfGame_Unite.prototype.updatePutGame = function(){
		this.updatePutInput();
		this.updatePutFight();
		this.updatePutFightMeter();
	}

	WolfGame_Unite.prototype.updatePutInput = function(){
		if($gameSystem.wolfIsTriggeredOkorTouch()){
			var dierX = 0;
		//if($gameSystem.wolfIsPressedOkorTouch()){
			if(TouchInput.x < window.innerWidth / 2) dierX = 816;
			this.pushFight(TouchInput.x,TouchInput.y,dierX,312,408,312);//気合マークの作成
			WolfGame_Base.prototype.playSe(this._seFight);//SEの再生
		}	
	}

	//メータをすこしづつ動かす
	WolfGame_Unite.prototype.updatePutFightMeter = function(){

		if(this._quonFight < this._quonFightSave){
			this._quonFight += 0.25;
		}
		if(this._quonFight >= this._maxFight){
			WolfGame_Base.prototype.playSe(this._seFanFare);//SEの再生
			WolfGame_Base.prototype.onEndSwitche.call(this);
		}
	}

	//ファイトをベジュする
	WolfGame_Unite.prototype.updatePutFight = function(){
		for(var i = 0 ; i < this._fight.length ; i++){
			
			var startPX = this._fight[i][1].x;
			var startPY = this._fight[i][1].y;

			var dierPX = this._fight[i][2].x;
			var dierPY = this._fight[i][2].y;

			var endPX = this._fight[i][3].x;
			var endPY = this._fight[i][3].y;

			var time = this._fight[i][4] / this._timeBezi;

			this._fight[i][0].x = $gameSystem.wolfBezier(startPX,dierPX,endPX,time);
			this._fight[i][0].y = $gameSystem.wolfBezier(startPY,dierPY,endPY,time);

			this._fight[i][4] += 1;

			if(time >= 1){
				this.deletePutFight(i + 1);
			}
		}
	}

	//気合の先頭を削除する
	WolfGame_Unite.prototype.deletePutFight = function(i){
		this._fight.shift();
		//this.addMaxPicId(-1);
		this.addFight(this._addFight);//ファイトを足す
		var x = Math.random() * (816 - 50) + 50;
		var y = Math.random() * (624 - 50) + 50;
		WolfGame_Base.prototype.criateMarkEffect.call(this,x,312 + 50,"GOOD");//エフェクト			
		WolfGame_Base.prototype.playSe(this._seGood);//SEの再生

		//this._fight.splice(0,i);
	}

	//動的に画像が増えていくので、消すためのPICIDも変化させる、減らすときはマイナスを引数に
	/*WolfGame_Unite.prototype.addMaxPicId = function(add){
		this._maxPicId += add;
	}*/

	WolfGame_Unite.prototype.addFight = function(add){
		this._quonFightSave = Math.min(this._quonFightSave + add , this._maxFight);
	}

	//=============================-
	// ゲーム描画関係
	//=============================-

	WolfGame_Unite.prototype.draw = function(){
		WolfGame_Base.prototype.draw.call(this);

		this.chooseDrawScene();
	}


	//シーンによって描画メソッドを選ぶ
	WolfGame_Unite.prototype.chooseDrawScene = function(){

		switch(this._gameScene){
			case 0:
				this.drawTurnGame();
				break;
			case 1:
				this.drawPourGame();
				break;	
			case 2:
				this.drawPutGame();
				break;
			}
	}

	//=============================-
	// ゲーム描画関係 - Turn -
	//=============================-

	WolfGame_Unite.prototype.drawTurnGame = function(){
		this.drawTurnBackGround(1);
		this.drawTurnBowl(2);
		this.drawTurnArow(3);
	}

	WolfGame_Unite.prototype.drawTurnBackGround = function(id){
		$gameScreen.showPicture(id,"Unite_TurnBack",0,0,0,100.0,100.0,255,0);	

	}

	WolfGame_Unite.prototype.drawTurnBowl = function(id){
		var fileName = "Unite_TurnBowl" + (this._arowIndex % 2 + 1);
		$gameScreen.showPicture(id,fileName,1,408,282,100.0,100.0,255,0);	
	}


	WolfGame_Unite.prototype.drawTurnArow = function(id){

		var num = this._arowIndex;
		$gameScreen.showPicture(id,"Unite_TurnArow",1,this._posiArow[num][0],this._posiArow[num][1],100.0,100.0,255,0);	
		$gameScreen.picture(id).changeAngle(90 * num);

	}



	//=============================-
	// ゲーム描画関係 - Pour -
	//=============================-

	WolfGame_Unite.prototype.drawPourGame = function(){
	//	this.drawPourBackGround(1);

		this.drawPourBackUnder(2);
		this.drawPourMold(3);

		this.drawPourChoco(4);

		this.drawPourBackTop(5);
		this.drawPourBowl(6);

		this.drawPourMoldTop(7);
	}

	WolfGame_Unite.prototype.drawPourBackGround = function(id){
		$gameScreen.showPicture(id,"Test_BackGround",0,0,0,100.0,100.0,255,0);	
	}

	WolfGame_Unite.prototype.drawPourBackUnder = function(id){
		$gameScreen.showPicture(id,"Unite_PourBackUnder",0,0,0,100.0,100.0,255,0);	

	}

	WolfGame_Unite.prototype.drawPourBackTop = function(id){
		$gameScreen.showPicture(id,"Unite_PourBackTop",0,0,0,100.0,100.0,255,0);	

	}

	WolfGame_Unite.prototype.drawPourBowl = function(id){
		var angle = 0;
		$gameScreen.showPicture(id,"Unite_PourBowl",1,this._posiBowl[0],this._posiBowl[1],100.0,100.0,255,0);	

		if(this._actBowl == false){
			angle = -45;
		}
			$gameScreen.picture(id).changeAngle(angle);

	}

	WolfGame_Unite.prototype.drawPourChoco = function(id){
		$gameScreen.showPicture(id,"Unite_PourChoco",1,this._posiChoco[0],this._posiChoco[1],100.0,100.0,255,0);	

	}

	WolfGame_Unite.prototype.drawPourMold = function(id){
		var fileName = "Unite_PourMold" + (this._inputCount + 1); 
		$gameScreen.showPicture(id,fileName,1,408,624 - 50 - 300 / 2,100.0,100.0,255,0);	

	}

	WolfGame_Unite.prototype.drawPourMoldTop = function(id){
		var fileName = "Unite_PourMoldTop" + (this._inputCount + 1); 
		//$gameScreen.showPicture(id,fileName,1,408,624  - 250 / 2,100.0,100.0,255,0);	
		$gameScreen.showPicture(id,fileName,1,408,624  - 250 / 2,100.0,100.0,255,0);	

	}

	//=============================-
	// ゲーム描画関係 - Put -
	//=============================-
	WolfGame_Unite.prototype.drawPutGame = function(){
		this.drawPutBackGround(1);
		this.drawPutMold(2);
		this.drawPutMeterBack(3);
		this.drawPutMeter(4);
		this.drawPutFightMark(5);
	}

	WolfGame_Unite.prototype.drawPutBackGround = function(id){
		$gameScreen.showPicture(id,"Unite_PutBack",0,0,0,100.0,100.0,255,0);	
	}

	WolfGame_Unite.prototype.drawPutMeterBack = function(id){
		$gameScreen.showPicture(id,"Unite_PutMeterBack",1,250 / 2 + 50,624 - 250 / 2,100.0,100.0,255,0);	

	}

	WolfGame_Unite.prototype.drawPutMeter = function(id){
		$gameScreen.showPicture(id,"Unite_PutMeter",1,250 / 2 + 50,624,100.0,100.0,255,0);	

		var angle = (90 * this._quonFight / this._maxFight) + 45;
		angle *= -1;
		$gameScreen.picture(id).changeAngle(angle);

	}

	WolfGame_Unite.prototype.drawPutFightMark  = function(id){
		//$gameScreen.showPicture(id,"Unite_PutFightMark",1,408,312,100.0,100.0,255,0);	
		for(var i = 0 ; i < this._fight.length ; i++){
			$gameScreen.showPicture(id + i,"Unite_PutFightMark",1,this._fight[i][0].x,this._fight[i][0].y,100.0,100.0,255,0);	
		}
	}

	WolfGame_Unite.prototype.drawPutMold = function(id){
		$gameScreen.showPicture(id,"Unite_PutMold",1,408,312,100.0,100.0,255,0);	
	}

	//=============================-
	// ゲーム終了関係
	//=============================-
	
	//=========================================
	//オブジェクト生成
	//=========================================
	var _WolfGame_Unite = new WolfGame_Unite();


	//=========================================
	// プラグインコマンドで制御
	//=========================================

	var _Game_Interpreter_pluginCommand = Game_Interpreter.prototype.pluginCommand;
	Game_Interpreter.prototype.pluginCommand = function(command,args)
	{
		_Game_Interpreter_pluginCommand.call(this,command,args);

		if(command === 'Wolf_UniteGame'){

			switch (args[0])
			{
			case 'set':
				_WolfGame_Unite.set();
				_WolfGame_Unite.setGameScene(Number(args[1]));
				
				break;			

			case 'main':
				_WolfGame_Unite.main();
				break;
			case 'end':
				_WolfGame_Unite.end();
				break;			
	
			}
		}

	};
		




})();
